//------------------------------------------------------------------------------
// PySyntaxBindings.cpp
// Generated Python bindings for syntax types
//
// SPDX-FileCopyrightText: Michael Popoloski
// SPDX-License-Identifier: MIT
//------------------------------------------------------------------------------
#include "pyslang.h"

#include "slang/syntax/AllSyntax.h"

void registerSyntaxNodes(py::module_& m) {
    py::class_<ExpressionSyntax, SyntaxNode>(m, "ExpressionSyntax");

    py::class_<DataTypeSyntax, ExpressionSyntax>(m, "DataTypeSyntax");

    py::class_<TimingControlSyntax, SyntaxNode>(m, "TimingControlSyntax");

    py::class_<SequenceExprSyntax, SyntaxNode>(m, "SequenceExprSyntax");

    py::class_<PropertyExprSyntax, SyntaxNode>(m, "PropertyExprSyntax");

    py::class_<EqualsValueClauseSyntax, SyntaxNode>(m, "EqualsValueClauseSyntax")
        .def_readwrite("equals", &EqualsValueClauseSyntax::equals)
        .def_readwrite("expr", &EqualsValueClauseSyntax::expr);

    py::class_<AttributeSpecSyntax, SyntaxNode>(m, "AttributeSpecSyntax")
        .def_readwrite("name", &AttributeSpecSyntax::name)
        .def_readwrite("value", &AttributeSpecSyntax::value);

    py::class_<AttributeInstanceSyntax, SyntaxNode>(m, "AttributeInstanceSyntax")
        .def_readwrite("openParen", &AttributeInstanceSyntax::openParen)
        .def_readwrite("specs", &AttributeInstanceSyntax::specs)
        .def_readwrite("closeParen", &AttributeInstanceSyntax::closeParen);

    py::class_<NamedLabelSyntax, SyntaxNode>(m, "NamedLabelSyntax")
        .def_readwrite("name", &NamedLabelSyntax::name)
        .def_readwrite("colon", &NamedLabelSyntax::colon);

    py::class_<StatementSyntax, SyntaxNode>(m, "StatementSyntax")
        .def_readwrite("label", &StatementSyntax::label)
        .def_readwrite("attributes", &StatementSyntax::attributes);

    py::class_<MemberSyntax, SyntaxNode>(m, "MemberSyntax")
        .def_readwrite("attributes", &MemberSyntax::attributes);

    py::class_<ArgumentSyntax, SyntaxNode>(m, "ArgumentSyntax");

    py::class_<EmptyArgumentSyntax, ArgumentSyntax>(m, "EmptyArgumentSyntax")
        .def_readwrite("placeholder", &EmptyArgumentSyntax::placeholder);

    py::class_<OrderedArgumentSyntax, ArgumentSyntax>(m, "OrderedArgumentSyntax")
        .def_readwrite("expr", &OrderedArgumentSyntax::expr);

    py::class_<NamedArgumentSyntax, ArgumentSyntax>(m, "NamedArgumentSyntax")
        .def_readwrite("dot", &NamedArgumentSyntax::dot)
        .def_readwrite("name", &NamedArgumentSyntax::name)
        .def_readwrite("openParen", &NamedArgumentSyntax::openParen)
        .def_readwrite("expr", &NamedArgumentSyntax::expr)
        .def_readwrite("closeParen", &NamedArgumentSyntax::closeParen);

    py::class_<ArgumentListSyntax, SyntaxNode>(m, "ArgumentListSyntax")
        .def_readwrite("openParen", &ArgumentListSyntax::openParen)
        .def_readwrite("parameters", &ArgumentListSyntax::parameters)
        .def_readwrite("closeParen", &ArgumentListSyntax::closeParen);

    py::class_<ParamAssignmentSyntax, SyntaxNode>(m, "ParamAssignmentSyntax");

    py::class_<OrderedParamAssignmentSyntax, ParamAssignmentSyntax>(m, "OrderedParamAssignmentSyntax")
        .def_readwrite("expr", &OrderedParamAssignmentSyntax::expr);

    py::class_<NamedParamAssignmentSyntax, ParamAssignmentSyntax>(m, "NamedParamAssignmentSyntax")
        .def_readwrite("dot", &NamedParamAssignmentSyntax::dot)
        .def_readwrite("name", &NamedParamAssignmentSyntax::name)
        .def_readwrite("openParen", &NamedParamAssignmentSyntax::openParen)
        .def_readwrite("expr", &NamedParamAssignmentSyntax::expr)
        .def_readwrite("closeParen", &NamedParamAssignmentSyntax::closeParen);

    py::class_<ParameterValueAssignmentSyntax, SyntaxNode>(m, "ParameterValueAssignmentSyntax")
        .def_readwrite("hash", &ParameterValueAssignmentSyntax::hash)
        .def_readwrite("openParen", &ParameterValueAssignmentSyntax::openParen)
        .def_readwrite("parameters", &ParameterValueAssignmentSyntax::parameters)
        .def_readwrite("closeParen", &ParameterValueAssignmentSyntax::closeParen);

    py::class_<PatternSyntax, SyntaxNode>(m, "PatternSyntax");

    py::class_<ParenthesizedPatternSyntax, PatternSyntax>(m, "ParenthesizedPatternSyntax")
        .def_readwrite("openParen", &ParenthesizedPatternSyntax::openParen)
        .def_readwrite("pattern", &ParenthesizedPatternSyntax::pattern)
        .def_readwrite("closeParen", &ParenthesizedPatternSyntax::closeParen);

    py::class_<VariablePatternSyntax, PatternSyntax>(m, "VariablePatternSyntax")
        .def_readwrite("dot", &VariablePatternSyntax::dot)
        .def_readwrite("variableName", &VariablePatternSyntax::variableName);

    py::class_<WildcardPatternSyntax, PatternSyntax>(m, "WildcardPatternSyntax")
        .def_readwrite("dotStar", &WildcardPatternSyntax::dotStar);

    py::class_<ExpressionPatternSyntax, PatternSyntax>(m, "ExpressionPatternSyntax")
        .def_readwrite("expr", &ExpressionPatternSyntax::expr);

    py::class_<TaggedPatternSyntax, PatternSyntax>(m, "TaggedPatternSyntax")
        .def_readwrite("tagged", &TaggedPatternSyntax::tagged)
        .def_readwrite("memberName", &TaggedPatternSyntax::memberName)
        .def_readwrite("pattern", &TaggedPatternSyntax::pattern);

    py::class_<StructurePatternMemberSyntax, SyntaxNode>(m, "StructurePatternMemberSyntax");

    py::class_<OrderedStructurePatternMemberSyntax, StructurePatternMemberSyntax>(m, "OrderedStructurePatternMemberSyntax")
        .def_readwrite("pattern", &OrderedStructurePatternMemberSyntax::pattern);

    py::class_<NamedStructurePatternMemberSyntax, StructurePatternMemberSyntax>(m, "NamedStructurePatternMemberSyntax")
        .def_readwrite("name", &NamedStructurePatternMemberSyntax::name)
        .def_readwrite("colon", &NamedStructurePatternMemberSyntax::colon)
        .def_readwrite("pattern", &NamedStructurePatternMemberSyntax::pattern);

    py::class_<StructurePatternSyntax, PatternSyntax>(m, "StructurePatternSyntax")
        .def_readwrite("openBrace", &StructurePatternSyntax::openBrace)
        .def_readwrite("members", &StructurePatternSyntax::members)
        .def_readwrite("closeBrace", &StructurePatternSyntax::closeBrace);

    py::class_<MatchesClauseSyntax, SyntaxNode>(m, "MatchesClauseSyntax")
        .def_readwrite("matchesKeyword", &MatchesClauseSyntax::matchesKeyword)
        .def_readwrite("pattern", &MatchesClauseSyntax::pattern);

    py::class_<ConditionalPatternSyntax, SyntaxNode>(m, "ConditionalPatternSyntax")
        .def_readwrite("expr", &ConditionalPatternSyntax::expr)
        .def_readwrite("matchesClause", &ConditionalPatternSyntax::matchesClause);

    py::class_<ConditionalPredicateSyntax, SyntaxNode>(m, "ConditionalPredicateSyntax")
        .def_readwrite("conditions", &ConditionalPredicateSyntax::conditions);

    py::class_<AssignmentPatternSyntax, SyntaxNode>(m, "AssignmentPatternSyntax");

    py::class_<SimpleAssignmentPatternSyntax, AssignmentPatternSyntax>(m, "SimpleAssignmentPatternSyntax")
        .def_readwrite("openBrace", &SimpleAssignmentPatternSyntax::openBrace)
        .def_readwrite("items", &SimpleAssignmentPatternSyntax::items)
        .def_readwrite("closeBrace", &SimpleAssignmentPatternSyntax::closeBrace);

    py::class_<AssignmentPatternItemSyntax, SyntaxNode>(m, "AssignmentPatternItemSyntax")
        .def_readwrite("key", &AssignmentPatternItemSyntax::key)
        .def_readwrite("colon", &AssignmentPatternItemSyntax::colon)
        .def_readwrite("expr", &AssignmentPatternItemSyntax::expr);

    py::class_<StructuredAssignmentPatternSyntax, AssignmentPatternSyntax>(m, "StructuredAssignmentPatternSyntax")
        .def_readwrite("openBrace", &StructuredAssignmentPatternSyntax::openBrace)
        .def_readwrite("items", &StructuredAssignmentPatternSyntax::items)
        .def_readwrite("closeBrace", &StructuredAssignmentPatternSyntax::closeBrace);

    py::class_<ReplicatedAssignmentPatternSyntax, AssignmentPatternSyntax>(m, "ReplicatedAssignmentPatternSyntax")
        .def_readwrite("openBrace", &ReplicatedAssignmentPatternSyntax::openBrace)
        .def_readwrite("countExpr", &ReplicatedAssignmentPatternSyntax::countExpr)
        .def_readwrite("innerOpenBrace", &ReplicatedAssignmentPatternSyntax::innerOpenBrace)
        .def_readwrite("items", &ReplicatedAssignmentPatternSyntax::items)
        .def_readwrite("innerCloseBrace", &ReplicatedAssignmentPatternSyntax::innerCloseBrace)
        .def_readwrite("closeBrace", &ReplicatedAssignmentPatternSyntax::closeBrace);

    py::class_<BadExpressionSyntax, ExpressionSyntax>(m, "BadExpressionSyntax")
        .def_readwrite("expr", &BadExpressionSyntax::expr);

    py::class_<PrimaryExpressionSyntax, ExpressionSyntax>(m, "PrimaryExpressionSyntax");

    py::class_<PrefixUnaryExpressionSyntax, ExpressionSyntax>(m, "PrefixUnaryExpressionSyntax")
        .def_readwrite("operatorToken", &PrefixUnaryExpressionSyntax::operatorToken)
        .def_readwrite("attributes", &PrefixUnaryExpressionSyntax::attributes)
        .def_readwrite("operand", &PrefixUnaryExpressionSyntax::operand);

    py::class_<PostfixUnaryExpressionSyntax, ExpressionSyntax>(m, "PostfixUnaryExpressionSyntax")
        .def_readwrite("operand", &PostfixUnaryExpressionSyntax::operand)
        .def_readwrite("attributes", &PostfixUnaryExpressionSyntax::attributes)
        .def_readwrite("operatorToken", &PostfixUnaryExpressionSyntax::operatorToken);

    py::class_<BinaryExpressionSyntax, ExpressionSyntax>(m, "BinaryExpressionSyntax")
        .def_readwrite("left", &BinaryExpressionSyntax::left)
        .def_readwrite("operatorToken", &BinaryExpressionSyntax::operatorToken)
        .def_readwrite("attributes", &BinaryExpressionSyntax::attributes)
        .def_readwrite("right", &BinaryExpressionSyntax::right);

    py::class_<MinTypMaxExpressionSyntax, ExpressionSyntax>(m, "MinTypMaxExpressionSyntax")
        .def_readwrite("min", &MinTypMaxExpressionSyntax::min)
        .def_readwrite("colon1", &MinTypMaxExpressionSyntax::colon1)
        .def_readwrite("typ", &MinTypMaxExpressionSyntax::typ)
        .def_readwrite("colon2", &MinTypMaxExpressionSyntax::colon2)
        .def_readwrite("max", &MinTypMaxExpressionSyntax::max);

    py::class_<TaggedUnionExpressionSyntax, ExpressionSyntax>(m, "TaggedUnionExpressionSyntax")
        .def_readwrite("tagged", &TaggedUnionExpressionSyntax::tagged)
        .def_readwrite("member", &TaggedUnionExpressionSyntax::member)
        .def_readwrite("expr", &TaggedUnionExpressionSyntax::expr);

    py::class_<ValueRangeExpressionSyntax, ExpressionSyntax>(m, "ValueRangeExpressionSyntax")
        .def_readwrite("openBracket", &ValueRangeExpressionSyntax::openBracket)
        .def_readwrite("left", &ValueRangeExpressionSyntax::left)
        .def_readwrite("colon", &ValueRangeExpressionSyntax::colon)
        .def_readwrite("right", &ValueRangeExpressionSyntax::right)
        .def_readwrite("closeBracket", &ValueRangeExpressionSyntax::closeBracket);

    py::class_<RangeListSyntax, SyntaxNode>(m, "RangeListSyntax")
        .def_readwrite("openBrace", &RangeListSyntax::openBrace)
        .def_readwrite("valueRanges", &RangeListSyntax::valueRanges)
        .def_readwrite("closeBrace", &RangeListSyntax::closeBrace);

    py::class_<InsideExpressionSyntax, ExpressionSyntax>(m, "InsideExpressionSyntax")
        .def_readwrite("expr", &InsideExpressionSyntax::expr)
        .def_readwrite("inside", &InsideExpressionSyntax::inside)
        .def_readwrite("ranges", &InsideExpressionSyntax::ranges);

    py::class_<ConditionalExpressionSyntax, ExpressionSyntax>(m, "ConditionalExpressionSyntax")
        .def_readwrite("predicate", &ConditionalExpressionSyntax::predicate)
        .def_readwrite("question", &ConditionalExpressionSyntax::question)
        .def_readwrite("attributes", &ConditionalExpressionSyntax::attributes)
        .def_readwrite("left", &ConditionalExpressionSyntax::left)
        .def_readwrite("colon", &ConditionalExpressionSyntax::colon)
        .def_readwrite("right", &ConditionalExpressionSyntax::right);

    py::class_<AssignmentPatternExpressionSyntax, PrimaryExpressionSyntax>(m, "AssignmentPatternExpressionSyntax")
        .def_readwrite("type", &AssignmentPatternExpressionSyntax::type)
        .def_readwrite("pattern", &AssignmentPatternExpressionSyntax::pattern);

    py::class_<SelectorSyntax, SyntaxNode>(m, "SelectorSyntax");

    py::class_<BitSelectSyntax, SelectorSyntax>(m, "BitSelectSyntax")
        .def_readwrite("expr", &BitSelectSyntax::expr);

    py::class_<RangeSelectSyntax, SelectorSyntax>(m, "RangeSelectSyntax")
        .def_readwrite("left", &RangeSelectSyntax::left)
        .def_readwrite("range", &RangeSelectSyntax::range)
        .def_readwrite("right", &RangeSelectSyntax::right);

    py::class_<ElementSelectSyntax, SyntaxNode>(m, "ElementSelectSyntax")
        .def_readwrite("openBracket", &ElementSelectSyntax::openBracket)
        .def_readwrite("selector", &ElementSelectSyntax::selector)
        .def_readwrite("closeBracket", &ElementSelectSyntax::closeBracket);

    py::class_<NameSyntax, ExpressionSyntax>(m, "NameSyntax");

    py::class_<IdentifierNameSyntax, NameSyntax>(m, "IdentifierNameSyntax")
        .def_readwrite("identifier", &IdentifierNameSyntax::identifier);

    py::class_<SystemNameSyntax, NameSyntax>(m, "SystemNameSyntax")
        .def_readwrite("systemIdentifier", &SystemNameSyntax::systemIdentifier);

    py::class_<IdentifierSelectNameSyntax, NameSyntax>(m, "IdentifierSelectNameSyntax")
        .def_readwrite("identifier", &IdentifierSelectNameSyntax::identifier)
        .def_readwrite("selectors", &IdentifierSelectNameSyntax::selectors);

    py::class_<EmptyIdentifierNameSyntax, NameSyntax>(m, "EmptyIdentifierNameSyntax")
        .def_readwrite("placeholder", &EmptyIdentifierNameSyntax::placeholder);

    py::class_<KeywordNameSyntax, NameSyntax>(m, "KeywordNameSyntax")
        .def_readwrite("keyword", &KeywordNameSyntax::keyword);

    py::class_<ClassNameSyntax, NameSyntax>(m, "ClassNameSyntax")
        .def_readwrite("identifier", &ClassNameSyntax::identifier)
        .def_readwrite("parameters", &ClassNameSyntax::parameters);

    py::class_<ScopedNameSyntax, NameSyntax>(m, "ScopedNameSyntax")
        .def_readwrite("left", &ScopedNameSyntax::left)
        .def_readwrite("separator", &ScopedNameSyntax::separator)
        .def_readwrite("right", &ScopedNameSyntax::right);

    py::class_<LiteralExpressionSyntax, PrimaryExpressionSyntax>(m, "LiteralExpressionSyntax")
        .def_readwrite("literal", &LiteralExpressionSyntax::literal);

    py::class_<IntegerVectorExpressionSyntax, PrimaryExpressionSyntax>(m, "IntegerVectorExpressionSyntax")
        .def_readwrite("size", &IntegerVectorExpressionSyntax::size)
        .def_readwrite("base", &IntegerVectorExpressionSyntax::base)
        .def_readwrite("value", &IntegerVectorExpressionSyntax::value);

    py::class_<EmptyQueueExpressionSyntax, PrimaryExpressionSyntax>(m, "EmptyQueueExpressionSyntax")
        .def_readwrite("openBrace", &EmptyQueueExpressionSyntax::openBrace)
        .def_readwrite("closeBrace", &EmptyQueueExpressionSyntax::closeBrace);

    py::class_<ConcatenationExpressionSyntax, PrimaryExpressionSyntax>(m, "ConcatenationExpressionSyntax")
        .def_readwrite("openBrace", &ConcatenationExpressionSyntax::openBrace)
        .def_readwrite("expressions", &ConcatenationExpressionSyntax::expressions)
        .def_readwrite("closeBrace", &ConcatenationExpressionSyntax::closeBrace);

    py::class_<MultipleConcatenationExpressionSyntax, PrimaryExpressionSyntax>(m, "MultipleConcatenationExpressionSyntax")
        .def_readwrite("openBrace", &MultipleConcatenationExpressionSyntax::openBrace)
        .def_readwrite("expression", &MultipleConcatenationExpressionSyntax::expression)
        .def_readwrite("concatenation", &MultipleConcatenationExpressionSyntax::concatenation)
        .def_readwrite("closeBrace", &MultipleConcatenationExpressionSyntax::closeBrace);

    py::class_<StreamExpressionWithRangeSyntax, SyntaxNode>(m, "StreamExpressionWithRangeSyntax")
        .def_readwrite("withKeyword", &StreamExpressionWithRangeSyntax::withKeyword)
        .def_readwrite("range", &StreamExpressionWithRangeSyntax::range);

    py::class_<StreamExpressionSyntax, SyntaxNode>(m, "StreamExpressionSyntax")
        .def_readwrite("expression", &StreamExpressionSyntax::expression)
        .def_readwrite("withRange", &StreamExpressionSyntax::withRange);

    py::class_<StreamingConcatenationExpressionSyntax, PrimaryExpressionSyntax>(m, "StreamingConcatenationExpressionSyntax")
        .def_readwrite("openBrace", &StreamingConcatenationExpressionSyntax::openBrace)
        .def_readwrite("operatorToken", &StreamingConcatenationExpressionSyntax::operatorToken)
        .def_readwrite("sliceSize", &StreamingConcatenationExpressionSyntax::sliceSize)
        .def_readwrite("innerOpenBrace", &StreamingConcatenationExpressionSyntax::innerOpenBrace)
        .def_readwrite("expressions", &StreamingConcatenationExpressionSyntax::expressions)
        .def_readwrite("innerCloseBrace", &StreamingConcatenationExpressionSyntax::innerCloseBrace)
        .def_readwrite("closeBrace", &StreamingConcatenationExpressionSyntax::closeBrace);

    py::class_<ParenthesizedExpressionSyntax, PrimaryExpressionSyntax>(m, "ParenthesizedExpressionSyntax")
        .def_readwrite("openParen", &ParenthesizedExpressionSyntax::openParen)
        .def_readwrite("expression", &ParenthesizedExpressionSyntax::expression)
        .def_readwrite("closeParen", &ParenthesizedExpressionSyntax::closeParen);

    py::class_<NewArrayExpressionSyntax, ExpressionSyntax>(m, "NewArrayExpressionSyntax")
        .def_readwrite("newKeyword", &NewArrayExpressionSyntax::newKeyword)
        .def_readwrite("openBracket", &NewArrayExpressionSyntax::openBracket)
        .def_readwrite("sizeExpr", &NewArrayExpressionSyntax::sizeExpr)
        .def_readwrite("closeBracket", &NewArrayExpressionSyntax::closeBracket)
        .def_readwrite("initializer", &NewArrayExpressionSyntax::initializer);

    py::class_<NewClassExpressionSyntax, ExpressionSyntax>(m, "NewClassExpressionSyntax")
        .def_readwrite("scopedNew", &NewClassExpressionSyntax::scopedNew)
        .def_readwrite("argList", &NewClassExpressionSyntax::argList);

    py::class_<CopyClassExpressionSyntax, ExpressionSyntax>(m, "CopyClassExpressionSyntax")
        .def_readwrite("scopedNew", &CopyClassExpressionSyntax::scopedNew)
        .def_readwrite("expr", &CopyClassExpressionSyntax::expr);

    py::class_<ElementSelectExpressionSyntax, ExpressionSyntax>(m, "ElementSelectExpressionSyntax")
        .def_readwrite("left", &ElementSelectExpressionSyntax::left)
        .def_readwrite("select", &ElementSelectExpressionSyntax::select);

    py::class_<MemberAccessExpressionSyntax, ExpressionSyntax>(m, "MemberAccessExpressionSyntax")
        .def_readwrite("left", &MemberAccessExpressionSyntax::left)
        .def_readwrite("dot", &MemberAccessExpressionSyntax::dot)
        .def_readwrite("name", &MemberAccessExpressionSyntax::name);

    py::class_<InvocationExpressionSyntax, ExpressionSyntax>(m, "InvocationExpressionSyntax")
        .def_readwrite("left", &InvocationExpressionSyntax::left)
        .def_readwrite("attributes", &InvocationExpressionSyntax::attributes)
        .def_readwrite("arguments", &InvocationExpressionSyntax::arguments);

    py::class_<CastExpressionSyntax, ExpressionSyntax>(m, "CastExpressionSyntax")
        .def_readwrite("left", &CastExpressionSyntax::left)
        .def_readwrite("apostrophe", &CastExpressionSyntax::apostrophe)
        .def_readwrite("right", &CastExpressionSyntax::right);

    py::class_<SignedCastExpressionSyntax, ExpressionSyntax>(m, "SignedCastExpressionSyntax")
        .def_readwrite("signing", &SignedCastExpressionSyntax::signing)
        .def_readwrite("apostrophe", &SignedCastExpressionSyntax::apostrophe)
        .def_readwrite("inner", &SignedCastExpressionSyntax::inner);

    py::class_<DelaySyntax, TimingControlSyntax>(m, "DelaySyntax")
        .def_readwrite("hash", &DelaySyntax::hash)
        .def_readwrite("delayValue", &DelaySyntax::delayValue);

    py::class_<Delay3Syntax, TimingControlSyntax>(m, "Delay3Syntax")
        .def_readwrite("hash", &Delay3Syntax::hash)
        .def_readwrite("openParen", &Delay3Syntax::openParen)
        .def_readwrite("delay1", &Delay3Syntax::delay1)
        .def_readwrite("comma1", &Delay3Syntax::comma1)
        .def_readwrite("delay2", &Delay3Syntax::delay2)
        .def_readwrite("comma2", &Delay3Syntax::comma2)
        .def_readwrite("delay3", &Delay3Syntax::delay3)
        .def_readwrite("closeParen", &Delay3Syntax::closeParen);

    py::class_<OneStepDelaySyntax, TimingControlSyntax>(m, "OneStepDelaySyntax")
        .def_readwrite("hash", &OneStepDelaySyntax::hash)
        .def_readwrite("oneStep", &OneStepDelaySyntax::oneStep);

    py::class_<EventControlSyntax, TimingControlSyntax>(m, "EventControlSyntax")
        .def_readwrite("at", &EventControlSyntax::at)
        .def_readwrite("eventName", &EventControlSyntax::eventName);

    py::class_<IffEventClauseSyntax, SyntaxNode>(m, "IffEventClauseSyntax")
        .def_readwrite("iff", &IffEventClauseSyntax::iff)
        .def_readwrite("expr", &IffEventClauseSyntax::expr);

    py::class_<EventExpressionSyntax, SequenceExprSyntax>(m, "EventExpressionSyntax");

    py::class_<SignalEventExpressionSyntax, EventExpressionSyntax>(m, "SignalEventExpressionSyntax")
        .def_readwrite("edge", &SignalEventExpressionSyntax::edge)
        .def_readwrite("expr", &SignalEventExpressionSyntax::expr)
        .def_readwrite("iffClause", &SignalEventExpressionSyntax::iffClause);

    py::class_<BinaryEventExpressionSyntax, EventExpressionSyntax>(m, "BinaryEventExpressionSyntax")
        .def_readwrite("left", &BinaryEventExpressionSyntax::left)
        .def_readwrite("operatorToken", &BinaryEventExpressionSyntax::operatorToken)
        .def_readwrite("right", &BinaryEventExpressionSyntax::right);

    py::class_<ParenthesizedEventExpressionSyntax, EventExpressionSyntax>(m, "ParenthesizedEventExpressionSyntax")
        .def_readwrite("openParen", &ParenthesizedEventExpressionSyntax::openParen)
        .def_readwrite("expr", &ParenthesizedEventExpressionSyntax::expr)
        .def_readwrite("closeParen", &ParenthesizedEventExpressionSyntax::closeParen);

    py::class_<ImplicitEventControlSyntax, TimingControlSyntax>(m, "ImplicitEventControlSyntax")
        .def_readwrite("at", &ImplicitEventControlSyntax::at)
        .def_readwrite("openParen", &ImplicitEventControlSyntax::openParen)
        .def_readwrite("star", &ImplicitEventControlSyntax::star)
        .def_readwrite("closeParen", &ImplicitEventControlSyntax::closeParen);

    py::class_<EventControlWithExpressionSyntax, TimingControlSyntax>(m, "EventControlWithExpressionSyntax")
        .def_readwrite("at", &EventControlWithExpressionSyntax::at)
        .def_readwrite("expr", &EventControlWithExpressionSyntax::expr);

    py::class_<RepeatedEventControlSyntax, TimingControlSyntax>(m, "RepeatedEventControlSyntax")
        .def_readwrite("repeat", &RepeatedEventControlSyntax::repeat)
        .def_readwrite("openParen", &RepeatedEventControlSyntax::openParen)
        .def_readwrite("expr", &RepeatedEventControlSyntax::expr)
        .def_readwrite("closeParen", &RepeatedEventControlSyntax::closeParen)
        .def_readwrite("eventControl", &RepeatedEventControlSyntax::eventControl);

    py::class_<TimingControlExpressionSyntax, ExpressionSyntax>(m, "TimingControlExpressionSyntax")
        .def_readwrite("timing", &TimingControlExpressionSyntax::timing)
        .def_readwrite("expr", &TimingControlExpressionSyntax::expr);

    py::class_<DimensionSpecifierSyntax, SyntaxNode>(m, "DimensionSpecifierSyntax");

    py::class_<RangeDimensionSpecifierSyntax, DimensionSpecifierSyntax>(m, "RangeDimensionSpecifierSyntax")
        .def_readwrite("selector", &RangeDimensionSpecifierSyntax::selector);

    py::class_<WildcardDimensionSpecifierSyntax, DimensionSpecifierSyntax>(m, "WildcardDimensionSpecifierSyntax")
        .def_readwrite("star", &WildcardDimensionSpecifierSyntax::star);

    py::class_<ColonExpressionClauseSyntax, SyntaxNode>(m, "ColonExpressionClauseSyntax")
        .def_readwrite("colon", &ColonExpressionClauseSyntax::colon)
        .def_readwrite("expr", &ColonExpressionClauseSyntax::expr);

    py::class_<QueueDimensionSpecifierSyntax, DimensionSpecifierSyntax>(m, "QueueDimensionSpecifierSyntax")
        .def_readwrite("dollar", &QueueDimensionSpecifierSyntax::dollar)
        .def_readwrite("maxSizeClause", &QueueDimensionSpecifierSyntax::maxSizeClause);

    py::class_<VariableDimensionSyntax, SyntaxNode>(m, "VariableDimensionSyntax")
        .def_readwrite("openBracket", &VariableDimensionSyntax::openBracket)
        .def_readwrite("specifier", &VariableDimensionSyntax::specifier)
        .def_readwrite("closeBracket", &VariableDimensionSyntax::closeBracket);

    py::class_<DeclaratorSyntax, SyntaxNode>(m, "DeclaratorSyntax")
        .def_readwrite("name", &DeclaratorSyntax::name)
        .def_readwrite("dimensions", &DeclaratorSyntax::dimensions)
        .def_readwrite("initializer", &DeclaratorSyntax::initializer);

    py::class_<DataDeclarationSyntax, MemberSyntax>(m, "DataDeclarationSyntax")
        .def_readwrite("modifiers", &DataDeclarationSyntax::modifiers)
        .def_readwrite("type", &DataDeclarationSyntax::type)
        .def_readwrite("declarators", &DataDeclarationSyntax::declarators)
        .def_readwrite("semi", &DataDeclarationSyntax::semi);

    py::class_<ForwardTypeRestrictionSyntax, SyntaxNode>(m, "ForwardTypeRestrictionSyntax")
        .def_readwrite("keyword1", &ForwardTypeRestrictionSyntax::keyword1)
        .def_readwrite("keyword2", &ForwardTypeRestrictionSyntax::keyword2);

    py::class_<TypedefDeclarationSyntax, MemberSyntax>(m, "TypedefDeclarationSyntax")
        .def_readwrite("typedefKeyword", &TypedefDeclarationSyntax::typedefKeyword)
        .def_readwrite("type", &TypedefDeclarationSyntax::type)
        .def_readwrite("name", &TypedefDeclarationSyntax::name)
        .def_readwrite("dimensions", &TypedefDeclarationSyntax::dimensions)
        .def_readwrite("semi", &TypedefDeclarationSyntax::semi);

    py::class_<ForwardTypedefDeclarationSyntax, MemberSyntax>(m, "ForwardTypedefDeclarationSyntax")
        .def_readwrite("typedefKeyword", &ForwardTypedefDeclarationSyntax::typedefKeyword)
        .def_readwrite("typeRestriction", &ForwardTypedefDeclarationSyntax::typeRestriction)
        .def_readwrite("name", &ForwardTypedefDeclarationSyntax::name)
        .def_readwrite("semi", &ForwardTypedefDeclarationSyntax::semi);

    py::class_<NetStrengthSyntax, SyntaxNode>(m, "NetStrengthSyntax");

    py::class_<ChargeStrengthSyntax, NetStrengthSyntax>(m, "ChargeStrengthSyntax")
        .def_readwrite("openParen", &ChargeStrengthSyntax::openParen)
        .def_readwrite("strength", &ChargeStrengthSyntax::strength)
        .def_readwrite("closeParen", &ChargeStrengthSyntax::closeParen);

    py::class_<DriveStrengthSyntax, NetStrengthSyntax>(m, "DriveStrengthSyntax")
        .def_readwrite("openParen", &DriveStrengthSyntax::openParen)
        .def_readwrite("strength0", &DriveStrengthSyntax::strength0)
        .def_readwrite("comma", &DriveStrengthSyntax::comma)
        .def_readwrite("strength1", &DriveStrengthSyntax::strength1)
        .def_readwrite("closeParen", &DriveStrengthSyntax::closeParen);

    py::class_<PullStrengthSyntax, NetStrengthSyntax>(m, "PullStrengthSyntax")
        .def_readwrite("openParen", &PullStrengthSyntax::openParen)
        .def_readwrite("strength", &PullStrengthSyntax::strength)
        .def_readwrite("closeParen", &PullStrengthSyntax::closeParen);

    py::class_<NetDeclarationSyntax, MemberSyntax>(m, "NetDeclarationSyntax")
        .def_readwrite("netType", &NetDeclarationSyntax::netType)
        .def_readwrite("strength", &NetDeclarationSyntax::strength)
        .def_readwrite("expansionHint", &NetDeclarationSyntax::expansionHint)
        .def_readwrite("type", &NetDeclarationSyntax::type)
        .def_readwrite("delay", &NetDeclarationSyntax::delay)
        .def_readwrite("declarators", &NetDeclarationSyntax::declarators)
        .def_readwrite("semi", &NetDeclarationSyntax::semi);

    py::class_<UserDefinedNetDeclarationSyntax, MemberSyntax>(m, "UserDefinedNetDeclarationSyntax")
        .def_readwrite("netType", &UserDefinedNetDeclarationSyntax::netType)
        .def_readwrite("delay", &UserDefinedNetDeclarationSyntax::delay)
        .def_readwrite("declarators", &UserDefinedNetDeclarationSyntax::declarators)
        .def_readwrite("semi", &UserDefinedNetDeclarationSyntax::semi);

    py::class_<WithFunctionClauseSyntax, SyntaxNode>(m, "WithFunctionClauseSyntax")
        .def_readwrite("with", &WithFunctionClauseSyntax::with)
        .def_readwrite("name", &WithFunctionClauseSyntax::name);

    py::class_<NetTypeDeclarationSyntax, MemberSyntax>(m, "NetTypeDeclarationSyntax")
        .def_readwrite("keyword", &NetTypeDeclarationSyntax::keyword)
        .def_readwrite("type", &NetTypeDeclarationSyntax::type)
        .def_readwrite("name", &NetTypeDeclarationSyntax::name)
        .def_readwrite("withFunction", &NetTypeDeclarationSyntax::withFunction)
        .def_readwrite("semi", &NetTypeDeclarationSyntax::semi);

    py::class_<PackageImportItemSyntax, SyntaxNode>(m, "PackageImportItemSyntax")
        .def_readwrite("package", &PackageImportItemSyntax::package)
        .def_readwrite("doubleColon", &PackageImportItemSyntax::doubleColon)
        .def_readwrite("item", &PackageImportItemSyntax::item);

    py::class_<PackageImportDeclarationSyntax, MemberSyntax>(m, "PackageImportDeclarationSyntax")
        .def_readwrite("keyword", &PackageImportDeclarationSyntax::keyword)
        .def_readwrite("items", &PackageImportDeclarationSyntax::items)
        .def_readwrite("semi", &PackageImportDeclarationSyntax::semi);

    py::class_<PackageExportDeclarationSyntax, MemberSyntax>(m, "PackageExportDeclarationSyntax")
        .def_readwrite("keyword", &PackageExportDeclarationSyntax::keyword)
        .def_readwrite("items", &PackageExportDeclarationSyntax::items)
        .def_readwrite("semi", &PackageExportDeclarationSyntax::semi);

    py::class_<PackageExportAllDeclarationSyntax, MemberSyntax>(m, "PackageExportAllDeclarationSyntax")
        .def_readwrite("keyword", &PackageExportAllDeclarationSyntax::keyword)
        .def_readwrite("star1", &PackageExportAllDeclarationSyntax::star1)
        .def_readwrite("doubleColon", &PackageExportAllDeclarationSyntax::doubleColon)
        .def_readwrite("star2", &PackageExportAllDeclarationSyntax::star2)
        .def_readwrite("semi", &PackageExportAllDeclarationSyntax::semi);

    py::class_<ParameterDeclarationBaseSyntax, SyntaxNode>(m, "ParameterDeclarationBaseSyntax")
        .def_readwrite("keyword", &ParameterDeclarationBaseSyntax::keyword);

    py::class_<ParameterDeclarationSyntax, ParameterDeclarationBaseSyntax>(m, "ParameterDeclarationSyntax")
        .def_readwrite("type", &ParameterDeclarationSyntax::type)
        .def_readwrite("declarators", &ParameterDeclarationSyntax::declarators);

    py::class_<EqualsTypeClauseSyntax, SyntaxNode>(m, "EqualsTypeClauseSyntax")
        .def_readwrite("equals", &EqualsTypeClauseSyntax::equals)
        .def_readwrite("type", &EqualsTypeClauseSyntax::type);

    py::class_<TypeAssignmentSyntax, SyntaxNode>(m, "TypeAssignmentSyntax")
        .def_readwrite("name", &TypeAssignmentSyntax::name)
        .def_readwrite("assignment", &TypeAssignmentSyntax::assignment);

    py::class_<TypeParameterDeclarationSyntax, ParameterDeclarationBaseSyntax>(m, "TypeParameterDeclarationSyntax")
        .def_readwrite("typeKeyword", &TypeParameterDeclarationSyntax::typeKeyword)
        .def_readwrite("typeRestriction", &TypeParameterDeclarationSyntax::typeRestriction)
        .def_readwrite("declarators", &TypeParameterDeclarationSyntax::declarators);

    py::class_<ParameterDeclarationStatementSyntax, MemberSyntax>(m, "ParameterDeclarationStatementSyntax")
        .def_readwrite("parameter", &ParameterDeclarationStatementSyntax::parameter)
        .def_readwrite("semi", &ParameterDeclarationStatementSyntax::semi);

    py::class_<PortHeaderSyntax, SyntaxNode>(m, "PortHeaderSyntax");

    py::class_<PortDeclarationSyntax, MemberSyntax>(m, "PortDeclarationSyntax")
        .def_readwrite("header", &PortDeclarationSyntax::header)
        .def_readwrite("declarators", &PortDeclarationSyntax::declarators)
        .def_readwrite("semi", &PortDeclarationSyntax::semi);

    py::class_<GenvarDeclarationSyntax, MemberSyntax>(m, "GenvarDeclarationSyntax")
        .def_readwrite("keyword", &GenvarDeclarationSyntax::keyword)
        .def_readwrite("identifiers", &GenvarDeclarationSyntax::identifiers)
        .def_readwrite("semi", &GenvarDeclarationSyntax::semi);

    py::class_<FunctionPortSyntax, SyntaxNode>(m, "FunctionPortSyntax")
        .def_readwrite("attributes", &FunctionPortSyntax::attributes)
        .def_readwrite("constKeyword", &FunctionPortSyntax::constKeyword)
        .def_readwrite("direction", &FunctionPortSyntax::direction)
        .def_readwrite("varKeyword", &FunctionPortSyntax::varKeyword)
        .def_readwrite("dataType", &FunctionPortSyntax::dataType)
        .def_readwrite("declarator", &FunctionPortSyntax::declarator);

    py::class_<FunctionPortListSyntax, SyntaxNode>(m, "FunctionPortListSyntax")
        .def_readwrite("openParen", &FunctionPortListSyntax::openParen)
        .def_readwrite("ports", &FunctionPortListSyntax::ports)
        .def_readwrite("closeParen", &FunctionPortListSyntax::closeParen);

    py::class_<IntegerTypeSyntax, DataTypeSyntax>(m, "IntegerTypeSyntax")
        .def_readwrite("keyword", &IntegerTypeSyntax::keyword)
        .def_readwrite("signing", &IntegerTypeSyntax::signing)
        .def_readwrite("dimensions", &IntegerTypeSyntax::dimensions);

    py::class_<KeywordTypeSyntax, DataTypeSyntax>(m, "KeywordTypeSyntax")
        .def_readwrite("keyword", &KeywordTypeSyntax::keyword);

    py::class_<NamedTypeSyntax, DataTypeSyntax>(m, "NamedTypeSyntax")
        .def_readwrite("name", &NamedTypeSyntax::name);

    py::class_<StructUnionMemberSyntax, SyntaxNode>(m, "StructUnionMemberSyntax")
        .def_readwrite("attributes", &StructUnionMemberSyntax::attributes)
        .def_readwrite("randomQualifier", &StructUnionMemberSyntax::randomQualifier)
        .def_readwrite("type", &StructUnionMemberSyntax::type)
        .def_readwrite("declarators", &StructUnionMemberSyntax::declarators)
        .def_readwrite("semi", &StructUnionMemberSyntax::semi);

    py::class_<StructUnionTypeSyntax, DataTypeSyntax>(m, "StructUnionTypeSyntax")
        .def_readwrite("keyword", &StructUnionTypeSyntax::keyword)
        .def_readwrite("taggedOrSoft", &StructUnionTypeSyntax::taggedOrSoft)
        .def_readwrite("packed", &StructUnionTypeSyntax::packed)
        .def_readwrite("signing", &StructUnionTypeSyntax::signing)
        .def_readwrite("openBrace", &StructUnionTypeSyntax::openBrace)
        .def_readwrite("members", &StructUnionTypeSyntax::members)
        .def_readwrite("closeBrace", &StructUnionTypeSyntax::closeBrace)
        .def_readwrite("dimensions", &StructUnionTypeSyntax::dimensions);

    py::class_<EnumTypeSyntax, DataTypeSyntax>(m, "EnumTypeSyntax")
        .def_readwrite("keyword", &EnumTypeSyntax::keyword)
        .def_readwrite("baseType", &EnumTypeSyntax::baseType)
        .def_readwrite("openBrace", &EnumTypeSyntax::openBrace)
        .def_readwrite("members", &EnumTypeSyntax::members)
        .def_readwrite("closeBrace", &EnumTypeSyntax::closeBrace)
        .def_readwrite("dimensions", &EnumTypeSyntax::dimensions);

    py::class_<TypeReferenceSyntax, DataTypeSyntax>(m, "TypeReferenceSyntax")
        .def_readwrite("typeKeyword", &TypeReferenceSyntax::typeKeyword)
        .def_readwrite("openParen", &TypeReferenceSyntax::openParen)
        .def_readwrite("expr", &TypeReferenceSyntax::expr)
        .def_readwrite("closeParen", &TypeReferenceSyntax::closeParen);

    py::class_<DotMemberClauseSyntax, SyntaxNode>(m, "DotMemberClauseSyntax")
        .def_readwrite("dot", &DotMemberClauseSyntax::dot)
        .def_readwrite("member", &DotMemberClauseSyntax::member);

    py::class_<VirtualInterfaceTypeSyntax, DataTypeSyntax>(m, "VirtualInterfaceTypeSyntax")
        .def_readwrite("virtualKeyword", &VirtualInterfaceTypeSyntax::virtualKeyword)
        .def_readwrite("interfaceKeyword", &VirtualInterfaceTypeSyntax::interfaceKeyword)
        .def_readwrite("name", &VirtualInterfaceTypeSyntax::name)
        .def_readwrite("parameters", &VirtualInterfaceTypeSyntax::parameters)
        .def_readwrite("modport", &VirtualInterfaceTypeSyntax::modport);

    py::class_<ImplicitTypeSyntax, DataTypeSyntax>(m, "ImplicitTypeSyntax")
        .def_readwrite("signing", &ImplicitTypeSyntax::signing)
        .def_readwrite("dimensions", &ImplicitTypeSyntax::dimensions)
        .def_readwrite("placeholder", &ImplicitTypeSyntax::placeholder);

    py::class_<DeferredAssertionSyntax, SyntaxNode>(m, "DeferredAssertionSyntax")
        .def_readwrite("hash", &DeferredAssertionSyntax::hash)
        .def_readwrite("zero", &DeferredAssertionSyntax::zero)
        .def_readwrite("finalKeyword", &DeferredAssertionSyntax::finalKeyword);

    py::class_<ElseClauseSyntax, SyntaxNode>(m, "ElseClauseSyntax")
        .def_readwrite("elseKeyword", &ElseClauseSyntax::elseKeyword)
        .def_readwrite("clause", &ElseClauseSyntax::clause);

    py::class_<ActionBlockSyntax, SyntaxNode>(m, "ActionBlockSyntax")
        .def_readwrite("statement", &ActionBlockSyntax::statement)
        .def_readwrite("elseClause", &ActionBlockSyntax::elseClause);

    py::class_<ImmediateAssertionStatementSyntax, StatementSyntax>(m, "ImmediateAssertionStatementSyntax")
        .def_readwrite("keyword", &ImmediateAssertionStatementSyntax::keyword)
        .def_readwrite("delay", &ImmediateAssertionStatementSyntax::delay)
        .def_readwrite("expr", &ImmediateAssertionStatementSyntax::expr)
        .def_readwrite("action", &ImmediateAssertionStatementSyntax::action);

    py::class_<DisableIffSyntax, SyntaxNode>(m, "DisableIffSyntax")
        .def_readwrite("disable", &DisableIffSyntax::disable)
        .def_readwrite("iff", &DisableIffSyntax::iff)
        .def_readwrite("openParen", &DisableIffSyntax::openParen)
        .def_readwrite("expr", &DisableIffSyntax::expr)
        .def_readwrite("closeParen", &DisableIffSyntax::closeParen);

    py::class_<PropertySpecSyntax, SyntaxNode>(m, "PropertySpecSyntax")
        .def_readwrite("clocking", &PropertySpecSyntax::clocking)
        .def_readwrite("disable", &PropertySpecSyntax::disable)
        .def_readwrite("expr", &PropertySpecSyntax::expr);

    py::class_<ConcurrentAssertionStatementSyntax, StatementSyntax>(m, "ConcurrentAssertionStatementSyntax")
        .def_readwrite("keyword", &ConcurrentAssertionStatementSyntax::keyword)
        .def_readwrite("propertyOrSequence", &ConcurrentAssertionStatementSyntax::propertyOrSequence)
        .def_readwrite("openParen", &ConcurrentAssertionStatementSyntax::openParen)
        .def_readwrite("propertySpec", &ConcurrentAssertionStatementSyntax::propertySpec)
        .def_readwrite("closeParen", &ConcurrentAssertionStatementSyntax::closeParen)
        .def_readwrite("action", &ConcurrentAssertionStatementSyntax::action);

    py::class_<ConcurrentAssertionMemberSyntax, MemberSyntax>(m, "ConcurrentAssertionMemberSyntax")
        .def_readwrite("statement", &ConcurrentAssertionMemberSyntax::statement);

    py::class_<ImmediateAssertionMemberSyntax, MemberSyntax>(m, "ImmediateAssertionMemberSyntax")
        .def_readwrite("statement", &ImmediateAssertionMemberSyntax::statement);

    py::class_<EmptyStatementSyntax, StatementSyntax>(m, "EmptyStatementSyntax")
        .def_readwrite("semicolon", &EmptyStatementSyntax::semicolon);

    py::class_<ConditionalStatementSyntax, StatementSyntax>(m, "ConditionalStatementSyntax")
        .def_readwrite("uniqueOrPriority", &ConditionalStatementSyntax::uniqueOrPriority)
        .def_readwrite("ifKeyword", &ConditionalStatementSyntax::ifKeyword)
        .def_readwrite("openParen", &ConditionalStatementSyntax::openParen)
        .def_readwrite("predicate", &ConditionalStatementSyntax::predicate)
        .def_readwrite("closeParen", &ConditionalStatementSyntax::closeParen)
        .def_readwrite("statement", &ConditionalStatementSyntax::statement)
        .def_readwrite("elseClause", &ConditionalStatementSyntax::elseClause);

    py::class_<CaseItemSyntax, SyntaxNode>(m, "CaseItemSyntax");

    py::class_<DefaultCaseItemSyntax, CaseItemSyntax>(m, "DefaultCaseItemSyntax")
        .def_readwrite("defaultKeyword", &DefaultCaseItemSyntax::defaultKeyword)
        .def_readwrite("colon", &DefaultCaseItemSyntax::colon)
        .def_readwrite("clause", &DefaultCaseItemSyntax::clause);

    py::class_<PatternCaseItemSyntax, CaseItemSyntax>(m, "PatternCaseItemSyntax")
        .def_readwrite("pattern", &PatternCaseItemSyntax::pattern)
        .def_readwrite("tripleAnd", &PatternCaseItemSyntax::tripleAnd)
        .def_readwrite("expr", &PatternCaseItemSyntax::expr)
        .def_readwrite("colon", &PatternCaseItemSyntax::colon)
        .def_readwrite("statement", &PatternCaseItemSyntax::statement);

    py::class_<StandardCaseItemSyntax, CaseItemSyntax>(m, "StandardCaseItemSyntax")
        .def_readwrite("expressions", &StandardCaseItemSyntax::expressions)
        .def_readwrite("colon", &StandardCaseItemSyntax::colon)
        .def_readwrite("clause", &StandardCaseItemSyntax::clause);

    py::class_<CaseStatementSyntax, StatementSyntax>(m, "CaseStatementSyntax")
        .def_readwrite("uniqueOrPriority", &CaseStatementSyntax::uniqueOrPriority)
        .def_readwrite("caseKeyword", &CaseStatementSyntax::caseKeyword)
        .def_readwrite("openParen", &CaseStatementSyntax::openParen)
        .def_readwrite("expr", &CaseStatementSyntax::expr)
        .def_readwrite("closeParen", &CaseStatementSyntax::closeParen)
        .def_readwrite("matchesOrInside", &CaseStatementSyntax::matchesOrInside)
        .def_readwrite("items", &CaseStatementSyntax::items)
        .def_readwrite("endcase", &CaseStatementSyntax::endcase);

    py::class_<ForeverStatementSyntax, StatementSyntax>(m, "ForeverStatementSyntax")
        .def_readwrite("foreverKeyword", &ForeverStatementSyntax::foreverKeyword)
        .def_readwrite("statement", &ForeverStatementSyntax::statement);

    py::class_<LoopStatementSyntax, StatementSyntax>(m, "LoopStatementSyntax")
        .def_readwrite("repeatOrWhile", &LoopStatementSyntax::repeatOrWhile)
        .def_readwrite("openParen", &LoopStatementSyntax::openParen)
        .def_readwrite("expr", &LoopStatementSyntax::expr)
        .def_readwrite("closeParen", &LoopStatementSyntax::closeParen)
        .def_readwrite("statement", &LoopStatementSyntax::statement);

    py::class_<DoWhileStatementSyntax, StatementSyntax>(m, "DoWhileStatementSyntax")
        .def_readwrite("doKeyword", &DoWhileStatementSyntax::doKeyword)
        .def_readwrite("statement", &DoWhileStatementSyntax::statement)
        .def_readwrite("whileKeyword", &DoWhileStatementSyntax::whileKeyword)
        .def_readwrite("openParen", &DoWhileStatementSyntax::openParen)
        .def_readwrite("expr", &DoWhileStatementSyntax::expr)
        .def_readwrite("closeParen", &DoWhileStatementSyntax::closeParen)
        .def_readwrite("semi", &DoWhileStatementSyntax::semi);

    py::class_<ForVariableDeclarationSyntax, SyntaxNode>(m, "ForVariableDeclarationSyntax")
        .def_readwrite("varKeyword", &ForVariableDeclarationSyntax::varKeyword)
        .def_readwrite("type", &ForVariableDeclarationSyntax::type)
        .def_readwrite("declarator", &ForVariableDeclarationSyntax::declarator);

    py::class_<ForLoopStatementSyntax, StatementSyntax>(m, "ForLoopStatementSyntax")
        .def_readwrite("forKeyword", &ForLoopStatementSyntax::forKeyword)
        .def_readwrite("openParen", &ForLoopStatementSyntax::openParen)
        .def_readwrite("initializers", &ForLoopStatementSyntax::initializers)
        .def_readwrite("semi1", &ForLoopStatementSyntax::semi1)
        .def_readwrite("stopExpr", &ForLoopStatementSyntax::stopExpr)
        .def_readwrite("semi2", &ForLoopStatementSyntax::semi2)
        .def_readwrite("steps", &ForLoopStatementSyntax::steps)
        .def_readwrite("closeParen", &ForLoopStatementSyntax::closeParen)
        .def_readwrite("statement", &ForLoopStatementSyntax::statement);

    py::class_<ForeachLoopListSyntax, SyntaxNode>(m, "ForeachLoopListSyntax")
        .def_readwrite("openParen", &ForeachLoopListSyntax::openParen)
        .def_readwrite("arrayName", &ForeachLoopListSyntax::arrayName)
        .def_readwrite("openBracket", &ForeachLoopListSyntax::openBracket)
        .def_readwrite("loopVariables", &ForeachLoopListSyntax::loopVariables)
        .def_readwrite("closeBracket", &ForeachLoopListSyntax::closeBracket)
        .def_readwrite("closeParen", &ForeachLoopListSyntax::closeParen);

    py::class_<ForeachLoopStatementSyntax, StatementSyntax>(m, "ForeachLoopStatementSyntax")
        .def_readwrite("keyword", &ForeachLoopStatementSyntax::keyword)
        .def_readwrite("loopList", &ForeachLoopStatementSyntax::loopList)
        .def_readwrite("statement", &ForeachLoopStatementSyntax::statement);

    py::class_<ReturnStatementSyntax, StatementSyntax>(m, "ReturnStatementSyntax")
        .def_readwrite("returnKeyword", &ReturnStatementSyntax::returnKeyword)
        .def_readwrite("returnValue", &ReturnStatementSyntax::returnValue)
        .def_readwrite("semi", &ReturnStatementSyntax::semi);

    py::class_<JumpStatementSyntax, StatementSyntax>(m, "JumpStatementSyntax")
        .def_readwrite("breakOrContinue", &JumpStatementSyntax::breakOrContinue)
        .def_readwrite("semi", &JumpStatementSyntax::semi);

    py::class_<TimingControlStatementSyntax, StatementSyntax>(m, "TimingControlStatementSyntax")
        .def_readwrite("timingControl", &TimingControlStatementSyntax::timingControl)
        .def_readwrite("statement", &TimingControlStatementSyntax::statement);

    py::class_<ExpressionStatementSyntax, StatementSyntax>(m, "ExpressionStatementSyntax")
        .def_readwrite("expr", &ExpressionStatementSyntax::expr)
        .def_readwrite("semi", &ExpressionStatementSyntax::semi);

    py::class_<VoidCastedCallStatementSyntax, StatementSyntax>(m, "VoidCastedCallStatementSyntax")
        .def_readwrite("voidKeyword", &VoidCastedCallStatementSyntax::voidKeyword)
        .def_readwrite("apostrophe", &VoidCastedCallStatementSyntax::apostrophe)
        .def_readwrite("openParen", &VoidCastedCallStatementSyntax::openParen)
        .def_readwrite("expr", &VoidCastedCallStatementSyntax::expr)
        .def_readwrite("closeParen", &VoidCastedCallStatementSyntax::closeParen)
        .def_readwrite("semi", &VoidCastedCallStatementSyntax::semi);

    py::class_<ProceduralAssignStatementSyntax, StatementSyntax>(m, "ProceduralAssignStatementSyntax")
        .def_readwrite("keyword", &ProceduralAssignStatementSyntax::keyword)
        .def_readwrite("expr", &ProceduralAssignStatementSyntax::expr)
        .def_readwrite("semi", &ProceduralAssignStatementSyntax::semi);

    py::class_<ProceduralDeassignStatementSyntax, StatementSyntax>(m, "ProceduralDeassignStatementSyntax")
        .def_readwrite("keyword", &ProceduralDeassignStatementSyntax::keyword)
        .def_readwrite("variable", &ProceduralDeassignStatementSyntax::variable)
        .def_readwrite("semi", &ProceduralDeassignStatementSyntax::semi);

    py::class_<DisableStatementSyntax, StatementSyntax>(m, "DisableStatementSyntax")
        .def_readwrite("disable", &DisableStatementSyntax::disable)
        .def_readwrite("name", &DisableStatementSyntax::name)
        .def_readwrite("semi", &DisableStatementSyntax::semi);

    py::class_<DisableForkStatementSyntax, StatementSyntax>(m, "DisableForkStatementSyntax")
        .def_readwrite("disable", &DisableForkStatementSyntax::disable)
        .def_readwrite("fork", &DisableForkStatementSyntax::fork)
        .def_readwrite("semi", &DisableForkStatementSyntax::semi);

    py::class_<NamedBlockClauseSyntax, SyntaxNode>(m, "NamedBlockClauseSyntax")
        .def_readwrite("colon", &NamedBlockClauseSyntax::colon)
        .def_readwrite("name", &NamedBlockClauseSyntax::name);

    py::class_<BlockStatementSyntax, StatementSyntax>(m, "BlockStatementSyntax")
        .def_readwrite("begin", &BlockStatementSyntax::begin)
        .def_readwrite("blockName", &BlockStatementSyntax::blockName)
        .def_readwrite("items", &BlockStatementSyntax::items)
        .def_readwrite("end", &BlockStatementSyntax::end)
        .def_readwrite("endBlockName", &BlockStatementSyntax::endBlockName);

    py::class_<WaitStatementSyntax, StatementSyntax>(m, "WaitStatementSyntax")
        .def_readwrite("wait", &WaitStatementSyntax::wait)
        .def_readwrite("openParen", &WaitStatementSyntax::openParen)
        .def_readwrite("expr", &WaitStatementSyntax::expr)
        .def_readwrite("closeParen", &WaitStatementSyntax::closeParen)
        .def_readwrite("statement", &WaitStatementSyntax::statement);

    py::class_<WaitForkStatementSyntax, StatementSyntax>(m, "WaitForkStatementSyntax")
        .def_readwrite("wait", &WaitForkStatementSyntax::wait)
        .def_readwrite("fork", &WaitForkStatementSyntax::fork)
        .def_readwrite("semi", &WaitForkStatementSyntax::semi);

    py::class_<WaitOrderStatementSyntax, StatementSyntax>(m, "WaitOrderStatementSyntax")
        .def_readwrite("wait_order", &WaitOrderStatementSyntax::wait_order)
        .def_readwrite("openParen", &WaitOrderStatementSyntax::openParen)
        .def_readwrite("names", &WaitOrderStatementSyntax::names)
        .def_readwrite("closeParen", &WaitOrderStatementSyntax::closeParen)
        .def_readwrite("action", &WaitOrderStatementSyntax::action);

    py::class_<RandCaseItemSyntax, SyntaxNode>(m, "RandCaseItemSyntax")
        .def_readwrite("expr", &RandCaseItemSyntax::expr)
        .def_readwrite("colon", &RandCaseItemSyntax::colon)
        .def_readwrite("statement", &RandCaseItemSyntax::statement);

    py::class_<RandCaseStatementSyntax, StatementSyntax>(m, "RandCaseStatementSyntax")
        .def_readwrite("randCase", &RandCaseStatementSyntax::randCase)
        .def_readwrite("items", &RandCaseStatementSyntax::items)
        .def_readwrite("endCase", &RandCaseStatementSyntax::endCase);

    py::class_<RsProdSyntax, SyntaxNode>(m, "RsProdSyntax");

    py::class_<RsProdItemSyntax, RsProdSyntax>(m, "RsProdItemSyntax")
        .def_readwrite("name", &RsProdItemSyntax::name)
        .def_readwrite("argList", &RsProdItemSyntax::argList);

    py::class_<RsCodeBlockSyntax, RsProdSyntax>(m, "RsCodeBlockSyntax")
        .def_readwrite("openBrace", &RsCodeBlockSyntax::openBrace)
        .def_readwrite("items", &RsCodeBlockSyntax::items)
        .def_readwrite("closeBrace", &RsCodeBlockSyntax::closeBrace);

    py::class_<RsElseClauseSyntax, SyntaxNode>(m, "RsElseClauseSyntax")
        .def_readwrite("keyword", &RsElseClauseSyntax::keyword)
        .def_readwrite("item", &RsElseClauseSyntax::item);

    py::class_<RsIfElseSyntax, RsProdSyntax>(m, "RsIfElseSyntax")
        .def_readwrite("keyword", &RsIfElseSyntax::keyword)
        .def_readwrite("openParen", &RsIfElseSyntax::openParen)
        .def_readwrite("condition", &RsIfElseSyntax::condition)
        .def_readwrite("closeParen", &RsIfElseSyntax::closeParen)
        .def_readwrite("ifItem", &RsIfElseSyntax::ifItem)
        .def_readwrite("elseClause", &RsIfElseSyntax::elseClause);

    py::class_<RsRepeatSyntax, RsProdSyntax>(m, "RsRepeatSyntax")
        .def_readwrite("keyword", &RsRepeatSyntax::keyword)
        .def_readwrite("openParen", &RsRepeatSyntax::openParen)
        .def_readwrite("expr", &RsRepeatSyntax::expr)
        .def_readwrite("closeParen", &RsRepeatSyntax::closeParen)
        .def_readwrite("item", &RsRepeatSyntax::item);

    py::class_<RsCaseItemSyntax, SyntaxNode>(m, "RsCaseItemSyntax");

    py::class_<DefaultRsCaseItemSyntax, RsCaseItemSyntax>(m, "DefaultRsCaseItemSyntax")
        .def_readwrite("defaultKeyword", &DefaultRsCaseItemSyntax::defaultKeyword)
        .def_readwrite("colon", &DefaultRsCaseItemSyntax::colon)
        .def_readwrite("item", &DefaultRsCaseItemSyntax::item)
        .def_readwrite("semi", &DefaultRsCaseItemSyntax::semi);

    py::class_<StandardRsCaseItemSyntax, RsCaseItemSyntax>(m, "StandardRsCaseItemSyntax")
        .def_readwrite("expressions", &StandardRsCaseItemSyntax::expressions)
        .def_readwrite("colon", &StandardRsCaseItemSyntax::colon)
        .def_readwrite("item", &StandardRsCaseItemSyntax::item)
        .def_readwrite("semi", &StandardRsCaseItemSyntax::semi);

    py::class_<RsCaseSyntax, RsProdSyntax>(m, "RsCaseSyntax")
        .def_readwrite("keyword", &RsCaseSyntax::keyword)
        .def_readwrite("openParen", &RsCaseSyntax::openParen)
        .def_readwrite("expr", &RsCaseSyntax::expr)
        .def_readwrite("closeParen", &RsCaseSyntax::closeParen)
        .def_readwrite("items", &RsCaseSyntax::items)
        .def_readwrite("endcase", &RsCaseSyntax::endcase);

    py::class_<RandJoinClauseSyntax, SyntaxNode>(m, "RandJoinClauseSyntax")
        .def_readwrite("rand", &RandJoinClauseSyntax::rand)
        .def_readwrite("join", &RandJoinClauseSyntax::join)
        .def_readwrite("expr", &RandJoinClauseSyntax::expr);

    py::class_<RsWeightClauseSyntax, SyntaxNode>(m, "RsWeightClauseSyntax")
        .def_readwrite("colonEqual", &RsWeightClauseSyntax::colonEqual)
        .def_readwrite("weight", &RsWeightClauseSyntax::weight)
        .def_readwrite("codeBlock", &RsWeightClauseSyntax::codeBlock);

    py::class_<RsRuleSyntax, SyntaxNode>(m, "RsRuleSyntax")
        .def_readwrite("randJoin", &RsRuleSyntax::randJoin)
        .def_readwrite("prods", &RsRuleSyntax::prods)
        .def_readwrite("weightClause", &RsRuleSyntax::weightClause);

    py::class_<ProductionSyntax, SyntaxNode>(m, "ProductionSyntax")
        .def_readwrite("dataType", &ProductionSyntax::dataType)
        .def_readwrite("name", &ProductionSyntax::name)
        .def_readwrite("portList", &ProductionSyntax::portList)
        .def_readwrite("colon", &ProductionSyntax::colon)
        .def_readwrite("rules", &ProductionSyntax::rules)
        .def_readwrite("semi", &ProductionSyntax::semi);

    py::class_<RandSequenceStatementSyntax, StatementSyntax>(m, "RandSequenceStatementSyntax")
        .def_readwrite("randsequence", &RandSequenceStatementSyntax::randsequence)
        .def_readwrite("openParen", &RandSequenceStatementSyntax::openParen)
        .def_readwrite("firstProduction", &RandSequenceStatementSyntax::firstProduction)
        .def_readwrite("closeParen", &RandSequenceStatementSyntax::closeParen)
        .def_readwrite("productions", &RandSequenceStatementSyntax::productions)
        .def_readwrite("endsequence", &RandSequenceStatementSyntax::endsequence);

    py::class_<EventTriggerStatementSyntax, StatementSyntax>(m, "EventTriggerStatementSyntax")
        .def_readwrite("trigger", &EventTriggerStatementSyntax::trigger)
        .def_readwrite("timing", &EventTriggerStatementSyntax::timing)
        .def_readwrite("name", &EventTriggerStatementSyntax::name)
        .def_readwrite("semi", &EventTriggerStatementSyntax::semi);

    py::class_<PortListSyntax, SyntaxNode>(m, "PortListSyntax");

    py::class_<NonAnsiPortSyntax, SyntaxNode>(m, "NonAnsiPortSyntax");

    py::class_<PortExpressionSyntax, SyntaxNode>(m, "PortExpressionSyntax");

    py::class_<PortReferenceSyntax, PortExpressionSyntax>(m, "PortReferenceSyntax")
        .def_readwrite("name", &PortReferenceSyntax::name)
        .def_readwrite("select", &PortReferenceSyntax::select);

    py::class_<PortConcatenationSyntax, PortExpressionSyntax>(m, "PortConcatenationSyntax")
        .def_readwrite("openBrace", &PortConcatenationSyntax::openBrace)
        .def_readwrite("references", &PortConcatenationSyntax::references)
        .def_readwrite("closeBrace", &PortConcatenationSyntax::closeBrace);

    py::class_<EmptyNonAnsiPortSyntax, NonAnsiPortSyntax>(m, "EmptyNonAnsiPortSyntax")
        .def_readwrite("placeholder", &EmptyNonAnsiPortSyntax::placeholder);

    py::class_<ImplicitNonAnsiPortSyntax, NonAnsiPortSyntax>(m, "ImplicitNonAnsiPortSyntax")
        .def_readwrite("expr", &ImplicitNonAnsiPortSyntax::expr);

    py::class_<ExplicitNonAnsiPortSyntax, NonAnsiPortSyntax>(m, "ExplicitNonAnsiPortSyntax")
        .def_readwrite("dot", &ExplicitNonAnsiPortSyntax::dot)
        .def_readwrite("name", &ExplicitNonAnsiPortSyntax::name)
        .def_readwrite("openParen", &ExplicitNonAnsiPortSyntax::openParen)
        .def_readwrite("expr", &ExplicitNonAnsiPortSyntax::expr)
        .def_readwrite("closeParen", &ExplicitNonAnsiPortSyntax::closeParen);

    py::class_<NonAnsiPortListSyntax, PortListSyntax>(m, "NonAnsiPortListSyntax")
        .def_readwrite("openParen", &NonAnsiPortListSyntax::openParen)
        .def_readwrite("ports", &NonAnsiPortListSyntax::ports)
        .def_readwrite("closeParen", &NonAnsiPortListSyntax::closeParen);

    py::class_<InterfacePortHeaderSyntax, PortHeaderSyntax>(m, "InterfacePortHeaderSyntax")
        .def_readwrite("nameOrKeyword", &InterfacePortHeaderSyntax::nameOrKeyword)
        .def_readwrite("modport", &InterfacePortHeaderSyntax::modport);

    py::class_<VariablePortHeaderSyntax, PortHeaderSyntax>(m, "VariablePortHeaderSyntax")
        .def_readwrite("constKeyword", &VariablePortHeaderSyntax::constKeyword)
        .def_readwrite("direction", &VariablePortHeaderSyntax::direction)
        .def_readwrite("varKeyword", &VariablePortHeaderSyntax::varKeyword)
        .def_readwrite("dataType", &VariablePortHeaderSyntax::dataType);

    py::class_<NetPortHeaderSyntax, PortHeaderSyntax>(m, "NetPortHeaderSyntax")
        .def_readwrite("direction", &NetPortHeaderSyntax::direction)
        .def_readwrite("netType", &NetPortHeaderSyntax::netType)
        .def_readwrite("dataType", &NetPortHeaderSyntax::dataType);

    py::class_<ImplicitAnsiPortSyntax, MemberSyntax>(m, "ImplicitAnsiPortSyntax")
        .def_readwrite("header", &ImplicitAnsiPortSyntax::header)
        .def_readwrite("declarator", &ImplicitAnsiPortSyntax::declarator);

    py::class_<ExplicitAnsiPortSyntax, MemberSyntax>(m, "ExplicitAnsiPortSyntax")
        .def_readwrite("direction", &ExplicitAnsiPortSyntax::direction)
        .def_readwrite("dot", &ExplicitAnsiPortSyntax::dot)
        .def_readwrite("name", &ExplicitAnsiPortSyntax::name)
        .def_readwrite("openParen", &ExplicitAnsiPortSyntax::openParen)
        .def_readwrite("expr", &ExplicitAnsiPortSyntax::expr)
        .def_readwrite("closeParen", &ExplicitAnsiPortSyntax::closeParen);

    py::class_<AnsiPortListSyntax, PortListSyntax>(m, "AnsiPortListSyntax")
        .def_readwrite("openParen", &AnsiPortListSyntax::openParen)
        .def_readwrite("ports", &AnsiPortListSyntax::ports)
        .def_readwrite("closeParen", &AnsiPortListSyntax::closeParen);

    py::class_<WildcardPortListSyntax, PortListSyntax>(m, "WildcardPortListSyntax")
        .def_readwrite("openParen", &WildcardPortListSyntax::openParen)
        .def_readwrite("dotStar", &WildcardPortListSyntax::dotStar)
        .def_readwrite("closeParen", &WildcardPortListSyntax::closeParen);

    py::class_<ParameterPortListSyntax, SyntaxNode>(m, "ParameterPortListSyntax")
        .def_readwrite("hash", &ParameterPortListSyntax::hash)
        .def_readwrite("openParen", &ParameterPortListSyntax::openParen)
        .def_readwrite("declarations", &ParameterPortListSyntax::declarations)
        .def_readwrite("closeParen", &ParameterPortListSyntax::closeParen);

    py::class_<ModuleHeaderSyntax, SyntaxNode>(m, "ModuleHeaderSyntax")
        .def_readwrite("moduleKeyword", &ModuleHeaderSyntax::moduleKeyword)
        .def_readwrite("lifetime", &ModuleHeaderSyntax::lifetime)
        .def_readwrite("name", &ModuleHeaderSyntax::name)
        .def_readwrite("imports", &ModuleHeaderSyntax::imports)
        .def_readwrite("parameters", &ModuleHeaderSyntax::parameters)
        .def_readwrite("ports", &ModuleHeaderSyntax::ports)
        .def_readwrite("semi", &ModuleHeaderSyntax::semi);

    py::class_<ModuleDeclarationSyntax, MemberSyntax>(m, "ModuleDeclarationSyntax")
        .def_readwrite("header", &ModuleDeclarationSyntax::header)
        .def_readwrite("members", &ModuleDeclarationSyntax::members)
        .def_readwrite("endmodule", &ModuleDeclarationSyntax::endmodule)
        .def_readwrite("blockName", &ModuleDeclarationSyntax::blockName);

    py::class_<AnonymousProgramSyntax, MemberSyntax>(m, "AnonymousProgramSyntax")
        .def_readwrite("keyword", &AnonymousProgramSyntax::keyword)
        .def_readwrite("semi", &AnonymousProgramSyntax::semi)
        .def_readwrite("members", &AnonymousProgramSyntax::members)
        .def_readwrite("endkeyword", &AnonymousProgramSyntax::endkeyword);

    py::class_<EmptyMemberSyntax, MemberSyntax>(m, "EmptyMemberSyntax")
        .def_readwrite("qualifiers", &EmptyMemberSyntax::qualifiers)
        .def_readwrite("semi", &EmptyMemberSyntax::semi);

    py::class_<ProceduralBlockSyntax, MemberSyntax>(m, "ProceduralBlockSyntax")
        .def_readwrite("keyword", &ProceduralBlockSyntax::keyword)
        .def_readwrite("statement", &ProceduralBlockSyntax::statement);

    py::class_<GenerateRegionSyntax, MemberSyntax>(m, "GenerateRegionSyntax")
        .def_readwrite("keyword", &GenerateRegionSyntax::keyword)
        .def_readwrite("members", &GenerateRegionSyntax::members)
        .def_readwrite("endgenerate", &GenerateRegionSyntax::endgenerate);

    py::class_<LoopGenerateSyntax, MemberSyntax>(m, "LoopGenerateSyntax")
        .def_readwrite("keyword", &LoopGenerateSyntax::keyword)
        .def_readwrite("openParen", &LoopGenerateSyntax::openParen)
        .def_readwrite("genvar", &LoopGenerateSyntax::genvar)
        .def_readwrite("identifier", &LoopGenerateSyntax::identifier)
        .def_readwrite("equals", &LoopGenerateSyntax::equals)
        .def_readwrite("initialExpr", &LoopGenerateSyntax::initialExpr)
        .def_readwrite("semi1", &LoopGenerateSyntax::semi1)
        .def_readwrite("stopExpr", &LoopGenerateSyntax::stopExpr)
        .def_readwrite("semi2", &LoopGenerateSyntax::semi2)
        .def_readwrite("iterationExpr", &LoopGenerateSyntax::iterationExpr)
        .def_readwrite("closeParen", &LoopGenerateSyntax::closeParen)
        .def_readwrite("block", &LoopGenerateSyntax::block);

    py::class_<IfGenerateSyntax, MemberSyntax>(m, "IfGenerateSyntax")
        .def_readwrite("keyword", &IfGenerateSyntax::keyword)
        .def_readwrite("openParen", &IfGenerateSyntax::openParen)
        .def_readwrite("condition", &IfGenerateSyntax::condition)
        .def_readwrite("closeParen", &IfGenerateSyntax::closeParen)
        .def_readwrite("block", &IfGenerateSyntax::block)
        .def_readwrite("elseClause", &IfGenerateSyntax::elseClause);

    py::class_<CaseGenerateSyntax, MemberSyntax>(m, "CaseGenerateSyntax")
        .def_readwrite("keyword", &CaseGenerateSyntax::keyword)
        .def_readwrite("openParen", &CaseGenerateSyntax::openParen)
        .def_readwrite("condition", &CaseGenerateSyntax::condition)
        .def_readwrite("closeParen", &CaseGenerateSyntax::closeParen)
        .def_readwrite("items", &CaseGenerateSyntax::items)
        .def_readwrite("endCase", &CaseGenerateSyntax::endCase);

    py::class_<GenerateBlockSyntax, MemberSyntax>(m, "GenerateBlockSyntax")
        .def_readwrite("label", &GenerateBlockSyntax::label)
        .def_readwrite("begin", &GenerateBlockSyntax::begin)
        .def_readwrite("beginName", &GenerateBlockSyntax::beginName)
        .def_readwrite("members", &GenerateBlockSyntax::members)
        .def_readwrite("end", &GenerateBlockSyntax::end)
        .def_readwrite("endName", &GenerateBlockSyntax::endName);

    py::class_<DividerClauseSyntax, SyntaxNode>(m, "DividerClauseSyntax")
        .def_readwrite("divide", &DividerClauseSyntax::divide)
        .def_readwrite("value", &DividerClauseSyntax::value);

    py::class_<TimeUnitsDeclarationSyntax, MemberSyntax>(m, "TimeUnitsDeclarationSyntax")
        .def_readwrite("keyword", &TimeUnitsDeclarationSyntax::keyword)
        .def_readwrite("time", &TimeUnitsDeclarationSyntax::time)
        .def_readwrite("divider", &TimeUnitsDeclarationSyntax::divider)
        .def_readwrite("semi", &TimeUnitsDeclarationSyntax::semi);

    py::class_<PortConnectionSyntax, SyntaxNode>(m, "PortConnectionSyntax")
        .def_readwrite("attributes", &PortConnectionSyntax::attributes);

    py::class_<EmptyPortConnectionSyntax, PortConnectionSyntax>(m, "EmptyPortConnectionSyntax")
        .def_readwrite("placeholder", &EmptyPortConnectionSyntax::placeholder);

    py::class_<OrderedPortConnectionSyntax, PortConnectionSyntax>(m, "OrderedPortConnectionSyntax")
        .def_readwrite("expr", &OrderedPortConnectionSyntax::expr);

    py::class_<NamedPortConnectionSyntax, PortConnectionSyntax>(m, "NamedPortConnectionSyntax")
        .def_readwrite("dot", &NamedPortConnectionSyntax::dot)
        .def_readwrite("name", &NamedPortConnectionSyntax::name)
        .def_readwrite("openParen", &NamedPortConnectionSyntax::openParen)
        .def_readwrite("expr", &NamedPortConnectionSyntax::expr)
        .def_readwrite("closeParen", &NamedPortConnectionSyntax::closeParen);

    py::class_<WildcardPortConnectionSyntax, PortConnectionSyntax>(m, "WildcardPortConnectionSyntax")
        .def_readwrite("dotStar", &WildcardPortConnectionSyntax::dotStar);

    py::class_<InstanceNameSyntax, SyntaxNode>(m, "InstanceNameSyntax")
        .def_readwrite("name", &InstanceNameSyntax::name)
        .def_readwrite("dimensions", &InstanceNameSyntax::dimensions);

    py::class_<HierarchicalInstanceSyntax, SyntaxNode>(m, "HierarchicalInstanceSyntax")
        .def_readwrite("decl", &HierarchicalInstanceSyntax::decl)
        .def_readwrite("openParen", &HierarchicalInstanceSyntax::openParen)
        .def_readwrite("connections", &HierarchicalInstanceSyntax::connections)
        .def_readwrite("closeParen", &HierarchicalInstanceSyntax::closeParen);

    py::class_<HierarchyInstantiationSyntax, MemberSyntax>(m, "HierarchyInstantiationSyntax")
        .def_readwrite("type", &HierarchyInstantiationSyntax::type)
        .def_readwrite("parameters", &HierarchyInstantiationSyntax::parameters)
        .def_readwrite("instances", &HierarchyInstantiationSyntax::instances)
        .def_readwrite("semi", &HierarchyInstantiationSyntax::semi);

    py::class_<PrimitiveInstantiationSyntax, MemberSyntax>(m, "PrimitiveInstantiationSyntax")
        .def_readwrite("type", &PrimitiveInstantiationSyntax::type)
        .def_readwrite("strength", &PrimitiveInstantiationSyntax::strength)
        .def_readwrite("delay", &PrimitiveInstantiationSyntax::delay)
        .def_readwrite("instances", &PrimitiveInstantiationSyntax::instances)
        .def_readwrite("semi", &PrimitiveInstantiationSyntax::semi);

    py::class_<CheckerInstantiationSyntax, MemberSyntax>(m, "CheckerInstantiationSyntax")
        .def_readwrite("type", &CheckerInstantiationSyntax::type)
        .def_readwrite("parameters", &CheckerInstantiationSyntax::parameters)
        .def_readwrite("instances", &CheckerInstantiationSyntax::instances)
        .def_readwrite("semi", &CheckerInstantiationSyntax::semi);

    py::class_<CheckerInstanceStatementSyntax, StatementSyntax>(m, "CheckerInstanceStatementSyntax")
        .def_readwrite("instance", &CheckerInstanceStatementSyntax::instance);

    py::class_<BindTargetListSyntax, SyntaxNode>(m, "BindTargetListSyntax")
        .def_readwrite("colon", &BindTargetListSyntax::colon)
        .def_readwrite("targets", &BindTargetListSyntax::targets);

    py::class_<BindDirectiveSyntax, MemberSyntax>(m, "BindDirectiveSyntax")
        .def_readwrite("bind", &BindDirectiveSyntax::bind)
        .def_readwrite("target", &BindDirectiveSyntax::target)
        .def_readwrite("targetInstances", &BindDirectiveSyntax::targetInstances)
        .def_readwrite("instantiation", &BindDirectiveSyntax::instantiation);

    py::class_<FunctionPrototypeSyntax, SyntaxNode>(m, "FunctionPrototypeSyntax")
        .def_readwrite("keyword", &FunctionPrototypeSyntax::keyword)
        .def_readwrite("lifetime", &FunctionPrototypeSyntax::lifetime)
        .def_readwrite("returnType", &FunctionPrototypeSyntax::returnType)
        .def_readwrite("name", &FunctionPrototypeSyntax::name)
        .def_readwrite("portList", &FunctionPrototypeSyntax::portList);

    py::class_<FunctionDeclarationSyntax, MemberSyntax>(m, "FunctionDeclarationSyntax")
        .def_readwrite("prototype", &FunctionDeclarationSyntax::prototype)
        .def_readwrite("semi", &FunctionDeclarationSyntax::semi)
        .def_readwrite("items", &FunctionDeclarationSyntax::items)
        .def_readwrite("end", &FunctionDeclarationSyntax::end)
        .def_readwrite("endBlockName", &FunctionDeclarationSyntax::endBlockName);

    py::class_<EqualsAssertionArgClauseSyntax, SyntaxNode>(m, "EqualsAssertionArgClauseSyntax")
        .def_readwrite("equals", &EqualsAssertionArgClauseSyntax::equals)
        .def_readwrite("expr", &EqualsAssertionArgClauseSyntax::expr);

    py::class_<AssertionItemPortSyntax, SyntaxNode>(m, "AssertionItemPortSyntax")
        .def_readwrite("attributes", &AssertionItemPortSyntax::attributes)
        .def_readwrite("local", &AssertionItemPortSyntax::local)
        .def_readwrite("direction", &AssertionItemPortSyntax::direction)
        .def_readwrite("type", &AssertionItemPortSyntax::type)
        .def_readwrite("name", &AssertionItemPortSyntax::name)
        .def_readwrite("dimensions", &AssertionItemPortSyntax::dimensions)
        .def_readwrite("defaultValue", &AssertionItemPortSyntax::defaultValue);

    py::class_<AssertionItemPortListSyntax, SyntaxNode>(m, "AssertionItemPortListSyntax")
        .def_readwrite("openParen", &AssertionItemPortListSyntax::openParen)
        .def_readwrite("ports", &AssertionItemPortListSyntax::ports)
        .def_readwrite("closeParen", &AssertionItemPortListSyntax::closeParen);

    py::class_<LetDeclarationSyntax, MemberSyntax>(m, "LetDeclarationSyntax")
        .def_readwrite("let", &LetDeclarationSyntax::let)
        .def_readwrite("identifier", &LetDeclarationSyntax::identifier)
        .def_readwrite("portList", &LetDeclarationSyntax::portList)
        .def_readwrite("equals", &LetDeclarationSyntax::equals)
        .def_readwrite("expr", &LetDeclarationSyntax::expr)
        .def_readwrite("semi", &LetDeclarationSyntax::semi);

    py::class_<ExtendsClauseSyntax, SyntaxNode>(m, "ExtendsClauseSyntax")
        .def_readwrite("keyword", &ExtendsClauseSyntax::keyword)
        .def_readwrite("baseName", &ExtendsClauseSyntax::baseName)
        .def_readwrite("arguments", &ExtendsClauseSyntax::arguments);

    py::class_<ImplementsClauseSyntax, SyntaxNode>(m, "ImplementsClauseSyntax")
        .def_readwrite("keyword", &ImplementsClauseSyntax::keyword)
        .def_readwrite("interfaces", &ImplementsClauseSyntax::interfaces);

    py::class_<ClassDeclarationSyntax, MemberSyntax>(m, "ClassDeclarationSyntax")
        .def_readwrite("virtualOrInterface", &ClassDeclarationSyntax::virtualOrInterface)
        .def_readwrite("classKeyword", &ClassDeclarationSyntax::classKeyword)
        .def_readwrite("lifetime", &ClassDeclarationSyntax::lifetime)
        .def_readwrite("name", &ClassDeclarationSyntax::name)
        .def_readwrite("parameters", &ClassDeclarationSyntax::parameters)
        .def_readwrite("extendsClause", &ClassDeclarationSyntax::extendsClause)
        .def_readwrite("implementsClause", &ClassDeclarationSyntax::implementsClause)
        .def_readwrite("semi", &ClassDeclarationSyntax::semi)
        .def_readwrite("items", &ClassDeclarationSyntax::items)
        .def_readwrite("endClass", &ClassDeclarationSyntax::endClass)
        .def_readwrite("endBlockName", &ClassDeclarationSyntax::endBlockName);

    py::class_<ClassPropertyDeclarationSyntax, MemberSyntax>(m, "ClassPropertyDeclarationSyntax")
        .def_readwrite("qualifiers", &ClassPropertyDeclarationSyntax::qualifiers)
        .def_readwrite("declaration", &ClassPropertyDeclarationSyntax::declaration);

    py::class_<ClassMethodDeclarationSyntax, MemberSyntax>(m, "ClassMethodDeclarationSyntax")
        .def_readwrite("qualifiers", &ClassMethodDeclarationSyntax::qualifiers)
        .def_readwrite("declaration", &ClassMethodDeclarationSyntax::declaration);

    py::class_<ClassMethodPrototypeSyntax, MemberSyntax>(m, "ClassMethodPrototypeSyntax")
        .def_readwrite("qualifiers", &ClassMethodPrototypeSyntax::qualifiers)
        .def_readwrite("prototype", &ClassMethodPrototypeSyntax::prototype)
        .def_readwrite("semi", &ClassMethodPrototypeSyntax::semi);

    py::class_<ContinuousAssignSyntax, MemberSyntax>(m, "ContinuousAssignSyntax")
        .def_readwrite("assign", &ContinuousAssignSyntax::assign)
        .def_readwrite("strength", &ContinuousAssignSyntax::strength)
        .def_readwrite("delay", &ContinuousAssignSyntax::delay)
        .def_readwrite("assignments", &ContinuousAssignSyntax::assignments)
        .def_readwrite("semi", &ContinuousAssignSyntax::semi);

    py::class_<DefParamAssignmentSyntax, SyntaxNode>(m, "DefParamAssignmentSyntax")
        .def_readwrite("name", &DefParamAssignmentSyntax::name)
        .def_readwrite("setter", &DefParamAssignmentSyntax::setter);

    py::class_<DefParamSyntax, MemberSyntax>(m, "DefParamSyntax")
        .def_readwrite("defparam", &DefParamSyntax::defparam)
        .def_readwrite("assignments", &DefParamSyntax::assignments)
        .def_readwrite("semi", &DefParamSyntax::semi);

    py::class_<ModportClockingPortSyntax, MemberSyntax>(m, "ModportClockingPortSyntax")
        .def_readwrite("clocking", &ModportClockingPortSyntax::clocking)
        .def_readwrite("name", &ModportClockingPortSyntax::name);

    py::class_<ModportPortSyntax, SyntaxNode>(m, "ModportPortSyntax");

    py::class_<ModportNamedPortSyntax, ModportPortSyntax>(m, "ModportNamedPortSyntax")
        .def_readwrite("name", &ModportNamedPortSyntax::name);

    py::class_<ModportExplicitPortSyntax, ModportPortSyntax>(m, "ModportExplicitPortSyntax")
        .def_readwrite("dot", &ModportExplicitPortSyntax::dot)
        .def_readwrite("name", &ModportExplicitPortSyntax::name)
        .def_readwrite("openParen", &ModportExplicitPortSyntax::openParen)
        .def_readwrite("expr", &ModportExplicitPortSyntax::expr)
        .def_readwrite("closeParen", &ModportExplicitPortSyntax::closeParen);

    py::class_<ModportSimplePortListSyntax, MemberSyntax>(m, "ModportSimplePortListSyntax")
        .def_readwrite("direction", &ModportSimplePortListSyntax::direction)
        .def_readwrite("ports", &ModportSimplePortListSyntax::ports);

    py::class_<ModportSubroutinePortSyntax, ModportPortSyntax>(m, "ModportSubroutinePortSyntax")
        .def_readwrite("prototype", &ModportSubroutinePortSyntax::prototype);

    py::class_<ModportSubroutinePortListSyntax, MemberSyntax>(m, "ModportSubroutinePortListSyntax")
        .def_readwrite("importExport", &ModportSubroutinePortListSyntax::importExport)
        .def_readwrite("ports", &ModportSubroutinePortListSyntax::ports);

    py::class_<ModportItemSyntax, SyntaxNode>(m, "ModportItemSyntax")
        .def_readwrite("name", &ModportItemSyntax::name)
        .def_readwrite("ports", &ModportItemSyntax::ports);

    py::class_<ModportDeclarationSyntax, MemberSyntax>(m, "ModportDeclarationSyntax")
        .def_readwrite("keyword", &ModportDeclarationSyntax::keyword)
        .def_readwrite("items", &ModportDeclarationSyntax::items)
        .def_readwrite("semi", &ModportDeclarationSyntax::semi);

    py::class_<ClockingSkewSyntax, SyntaxNode>(m, "ClockingSkewSyntax")
        .def_readwrite("edge", &ClockingSkewSyntax::edge)
        .def_readwrite("delay", &ClockingSkewSyntax::delay);

    py::class_<ClockingDirectionSyntax, SyntaxNode>(m, "ClockingDirectionSyntax")
        .def_readwrite("input", &ClockingDirectionSyntax::input)
        .def_readwrite("inputSkew", &ClockingDirectionSyntax::inputSkew)
        .def_readwrite("output", &ClockingDirectionSyntax::output)
        .def_readwrite("outputSkew", &ClockingDirectionSyntax::outputSkew);

    py::class_<DefaultSkewItemSyntax, MemberSyntax>(m, "DefaultSkewItemSyntax")
        .def_readwrite("keyword", &DefaultSkewItemSyntax::keyword)
        .def_readwrite("direction", &DefaultSkewItemSyntax::direction)
        .def_readwrite("semi", &DefaultSkewItemSyntax::semi);

    py::class_<ClockingItemSyntax, MemberSyntax>(m, "ClockingItemSyntax")
        .def_readwrite("direction", &ClockingItemSyntax::direction)
        .def_readwrite("decls", &ClockingItemSyntax::decls)
        .def_readwrite("semi", &ClockingItemSyntax::semi);

    py::class_<ClockingDeclarationSyntax, MemberSyntax>(m, "ClockingDeclarationSyntax")
        .def_readwrite("globalOrDefault", &ClockingDeclarationSyntax::globalOrDefault)
        .def_readwrite("clocking", &ClockingDeclarationSyntax::clocking)
        .def_readwrite("blockName", &ClockingDeclarationSyntax::blockName)
        .def_readwrite("at", &ClockingDeclarationSyntax::at)
        .def_readwrite("event", &ClockingDeclarationSyntax::event)
        .def_readwrite("semi", &ClockingDeclarationSyntax::semi)
        .def_readwrite("items", &ClockingDeclarationSyntax::items)
        .def_readwrite("endClocking", &ClockingDeclarationSyntax::endClocking)
        .def_readwrite("endBlockName", &ClockingDeclarationSyntax::endBlockName);

    py::class_<DefaultClockingReferenceSyntax, MemberSyntax>(m, "DefaultClockingReferenceSyntax")
        .def_readwrite("defaultKeyword", &DefaultClockingReferenceSyntax::defaultKeyword)
        .def_readwrite("clocking", &DefaultClockingReferenceSyntax::clocking)
        .def_readwrite("name", &DefaultClockingReferenceSyntax::name)
        .def_readwrite("semi", &DefaultClockingReferenceSyntax::semi);

    py::class_<DefaultDisableDeclarationSyntax, MemberSyntax>(m, "DefaultDisableDeclarationSyntax")
        .def_readwrite("defaultKeyword", &DefaultDisableDeclarationSyntax::defaultKeyword)
        .def_readwrite("disableKeyword", &DefaultDisableDeclarationSyntax::disableKeyword)
        .def_readwrite("iffKeyword", &DefaultDisableDeclarationSyntax::iffKeyword)
        .def_readwrite("expr", &DefaultDisableDeclarationSyntax::expr)
        .def_readwrite("semi", &DefaultDisableDeclarationSyntax::semi);

    py::class_<DPIImportSyntax, MemberSyntax>(m, "DPIImportSyntax")
        .def_readwrite("keyword", &DPIImportSyntax::keyword)
        .def_readwrite("specString", &DPIImportSyntax::specString)
        .def_readwrite("property", &DPIImportSyntax::property)
        .def_readwrite("c_identifier", &DPIImportSyntax::c_identifier)
        .def_readwrite("equals", &DPIImportSyntax::equals)
        .def_readwrite("method", &DPIImportSyntax::method)
        .def_readwrite("semi", &DPIImportSyntax::semi);

    py::class_<DPIExportSyntax, MemberSyntax>(m, "DPIExportSyntax")
        .def_readwrite("keyword", &DPIExportSyntax::keyword)
        .def_readwrite("specString", &DPIExportSyntax::specString)
        .def_readwrite("c_identifier", &DPIExportSyntax::c_identifier)
        .def_readwrite("equals", &DPIExportSyntax::equals)
        .def_readwrite("functionOrTask", &DPIExportSyntax::functionOrTask)
        .def_readwrite("name", &DPIExportSyntax::name)
        .def_readwrite("semi", &DPIExportSyntax::semi);

    py::class_<ElabSystemTaskSyntax, MemberSyntax>(m, "ElabSystemTaskSyntax")
        .def_readwrite("name", &ElabSystemTaskSyntax::name)
        .def_readwrite("arguments", &ElabSystemTaskSyntax::arguments)
        .def_readwrite("semi", &ElabSystemTaskSyntax::semi);

    py::class_<UdpPortDeclSyntax, SyntaxNode>(m, "UdpPortDeclSyntax")
        .def_readwrite("attributes", &UdpPortDeclSyntax::attributes);

    py::class_<UdpOutputPortDeclSyntax, UdpPortDeclSyntax>(m, "UdpOutputPortDeclSyntax")
        .def_readwrite("keyword", &UdpOutputPortDeclSyntax::keyword)
        .def_readwrite("reg", &UdpOutputPortDeclSyntax::reg)
        .def_readwrite("name", &UdpOutputPortDeclSyntax::name)
        .def_readwrite("initializer", &UdpOutputPortDeclSyntax::initializer);

    py::class_<UdpInputPortDeclSyntax, UdpPortDeclSyntax>(m, "UdpInputPortDeclSyntax")
        .def_readwrite("keyword", &UdpInputPortDeclSyntax::keyword)
        .def_readwrite("names", &UdpInputPortDeclSyntax::names);

    py::class_<UdpPortListSyntax, SyntaxNode>(m, "UdpPortListSyntax");

    py::class_<AnsiUdpPortListSyntax, UdpPortListSyntax>(m, "AnsiUdpPortListSyntax")
        .def_readwrite("openParen", &AnsiUdpPortListSyntax::openParen)
        .def_readwrite("ports", &AnsiUdpPortListSyntax::ports)
        .def_readwrite("closeParen", &AnsiUdpPortListSyntax::closeParen)
        .def_readwrite("semi", &AnsiUdpPortListSyntax::semi);

    py::class_<NonAnsiUdpPortListSyntax, UdpPortListSyntax>(m, "NonAnsiUdpPortListSyntax")
        .def_readwrite("openParen", &NonAnsiUdpPortListSyntax::openParen)
        .def_readwrite("ports", &NonAnsiUdpPortListSyntax::ports)
        .def_readwrite("closeParen", &NonAnsiUdpPortListSyntax::closeParen)
        .def_readwrite("semi", &NonAnsiUdpPortListSyntax::semi);

    py::class_<WildcardUdpPortListSyntax, UdpPortListSyntax>(m, "WildcardUdpPortListSyntax")
        .def_readwrite("openParen", &WildcardUdpPortListSyntax::openParen)
        .def_readwrite("dotStar", &WildcardUdpPortListSyntax::dotStar)
        .def_readwrite("closeParen", &WildcardUdpPortListSyntax::closeParen)
        .def_readwrite("semi", &WildcardUdpPortListSyntax::semi);

    py::class_<UdpInitialStmtSyntax, SyntaxNode>(m, "UdpInitialStmtSyntax")
        .def_readwrite("initial", &UdpInitialStmtSyntax::initial)
        .def_readwrite("name", &UdpInitialStmtSyntax::name)
        .def_readwrite("equals", &UdpInitialStmtSyntax::equals)
        .def_readwrite("value", &UdpInitialStmtSyntax::value)
        .def_readwrite("semi", &UdpInitialStmtSyntax::semi);

    py::class_<UdpFieldBaseSyntax, SyntaxNode>(m, "UdpFieldBaseSyntax");

    py::class_<UdpEdgeFieldSyntax, UdpFieldBaseSyntax>(m, "UdpEdgeFieldSyntax")
        .def_readwrite("openParen", &UdpEdgeFieldSyntax::openParen)
        .def_readwrite("first", &UdpEdgeFieldSyntax::first)
        .def_readwrite("second", &UdpEdgeFieldSyntax::second)
        .def_readwrite("closeParen", &UdpEdgeFieldSyntax::closeParen);

    py::class_<UdpSimpleFieldSyntax, UdpFieldBaseSyntax>(m, "UdpSimpleFieldSyntax")
        .def_readwrite("field", &UdpSimpleFieldSyntax::field);

    py::class_<UdpEntrySyntax, SyntaxNode>(m, "UdpEntrySyntax")
        .def_readwrite("inputs", &UdpEntrySyntax::inputs)
        .def_readwrite("colon1", &UdpEntrySyntax::colon1)
        .def_readwrite("current", &UdpEntrySyntax::current)
        .def_readwrite("colon2", &UdpEntrySyntax::colon2)
        .def_readwrite("next", &UdpEntrySyntax::next)
        .def_readwrite("semi", &UdpEntrySyntax::semi);

    py::class_<UdpBodySyntax, SyntaxNode>(m, "UdpBodySyntax")
        .def_readwrite("portDecls", &UdpBodySyntax::portDecls)
        .def_readwrite("initialStmt", &UdpBodySyntax::initialStmt)
        .def_readwrite("table", &UdpBodySyntax::table)
        .def_readwrite("entries", &UdpBodySyntax::entries)
        .def_readwrite("endtable", &UdpBodySyntax::endtable);

    py::class_<UdpDeclarationSyntax, MemberSyntax>(m, "UdpDeclarationSyntax")
        .def_readwrite("primitive", &UdpDeclarationSyntax::primitive)
        .def_readwrite("name", &UdpDeclarationSyntax::name)
        .def_readwrite("portList", &UdpDeclarationSyntax::portList)
        .def_readwrite("body", &UdpDeclarationSyntax::body)
        .def_readwrite("endprimitive", &UdpDeclarationSyntax::endprimitive)
        .def_readwrite("endBlockName", &UdpDeclarationSyntax::endBlockName);

    py::class_<SpecparamDeclaratorSyntax, SyntaxNode>(m, "SpecparamDeclaratorSyntax")
        .def_readwrite("name", &SpecparamDeclaratorSyntax::name)
        .def_readwrite("equals", &SpecparamDeclaratorSyntax::equals)
        .def_readwrite("openParen", &SpecparamDeclaratorSyntax::openParen)
        .def_readwrite("value1", &SpecparamDeclaratorSyntax::value1)
        .def_readwrite("comma", &SpecparamDeclaratorSyntax::comma)
        .def_readwrite("value2", &SpecparamDeclaratorSyntax::value2)
        .def_readwrite("closeParen", &SpecparamDeclaratorSyntax::closeParen);

    py::class_<SpecparamDeclarationSyntax, MemberSyntax>(m, "SpecparamDeclarationSyntax")
        .def_readwrite("keyword", &SpecparamDeclarationSyntax::keyword)
        .def_readwrite("type", &SpecparamDeclarationSyntax::type)
        .def_readwrite("declarators", &SpecparamDeclarationSyntax::declarators)
        .def_readwrite("semi", &SpecparamDeclarationSyntax::semi);

    py::class_<PathSuffixSyntax, SyntaxNode>(m, "PathSuffixSyntax");

    py::class_<SimplePathSuffixSyntax, PathSuffixSyntax>(m, "SimplePathSuffixSyntax")
        .def_readwrite("outputs", &SimplePathSuffixSyntax::outputs);

    py::class_<EdgeSensitivePathSuffixSyntax, PathSuffixSyntax>(m, "EdgeSensitivePathSuffixSyntax")
        .def_readwrite("openParen", &EdgeSensitivePathSuffixSyntax::openParen)
        .def_readwrite("outputs", &EdgeSensitivePathSuffixSyntax::outputs)
        .def_readwrite("polarityOperator", &EdgeSensitivePathSuffixSyntax::polarityOperator)
        .def_readwrite("colon", &EdgeSensitivePathSuffixSyntax::colon)
        .def_readwrite("expr", &EdgeSensitivePathSuffixSyntax::expr)
        .def_readwrite("closeParen", &EdgeSensitivePathSuffixSyntax::closeParen);

    py::class_<PathDescriptionSyntax, SyntaxNode>(m, "PathDescriptionSyntax")
        .def_readwrite("openParen", &PathDescriptionSyntax::openParen)
        .def_readwrite("edgeIdentifier", &PathDescriptionSyntax::edgeIdentifier)
        .def_readwrite("inputs", &PathDescriptionSyntax::inputs)
        .def_readwrite("polarityOperator", &PathDescriptionSyntax::polarityOperator)
        .def_readwrite("pathOperator", &PathDescriptionSyntax::pathOperator)
        .def_readwrite("suffix", &PathDescriptionSyntax::suffix)
        .def_readwrite("closeParen", &PathDescriptionSyntax::closeParen);

    py::class_<PathDeclarationSyntax, MemberSyntax>(m, "PathDeclarationSyntax")
        .def_readwrite("desc", &PathDeclarationSyntax::desc)
        .def_readwrite("equals", &PathDeclarationSyntax::equals)
        .def_readwrite("openParen", &PathDeclarationSyntax::openParen)
        .def_readwrite("delays", &PathDeclarationSyntax::delays)
        .def_readwrite("closeParen", &PathDeclarationSyntax::closeParen)
        .def_readwrite("semi", &PathDeclarationSyntax::semi);

    py::class_<ConditionalPathDeclarationSyntax, MemberSyntax>(m, "ConditionalPathDeclarationSyntax")
        .def_readwrite("keyword", &ConditionalPathDeclarationSyntax::keyword)
        .def_readwrite("openParen", &ConditionalPathDeclarationSyntax::openParen)
        .def_readwrite("predicate", &ConditionalPathDeclarationSyntax::predicate)
        .def_readwrite("closeParen", &ConditionalPathDeclarationSyntax::closeParen)
        .def_readwrite("path", &ConditionalPathDeclarationSyntax::path);

    py::class_<IfNonePathDeclarationSyntax, MemberSyntax>(m, "IfNonePathDeclarationSyntax")
        .def_readwrite("keyword", &IfNonePathDeclarationSyntax::keyword)
        .def_readwrite("path", &IfNonePathDeclarationSyntax::path);

    py::class_<PulseStyleDeclarationSyntax, MemberSyntax>(m, "PulseStyleDeclarationSyntax")
        .def_readwrite("keyword", &PulseStyleDeclarationSyntax::keyword)
        .def_readwrite("inputs", &PulseStyleDeclarationSyntax::inputs)
        .def_readwrite("semi", &PulseStyleDeclarationSyntax::semi);

    py::class_<TimingCheckArgSyntax, SyntaxNode>(m, "TimingCheckArgSyntax");

    py::class_<EmptyTimingCheckArgSyntax, TimingCheckArgSyntax>(m, "EmptyTimingCheckArgSyntax")
        .def_readwrite("placeholder", &EmptyTimingCheckArgSyntax::placeholder);

    py::class_<EdgeDescriptorSyntax, SyntaxNode>(m, "EdgeDescriptorSyntax")
        .def_readwrite("t1", &EdgeDescriptorSyntax::t1)
        .def_readwrite("t2", &EdgeDescriptorSyntax::t2);

    py::class_<EdgeControlSpecifierSyntax, SyntaxNode>(m, "EdgeControlSpecifierSyntax")
        .def_readwrite("openBracket", &EdgeControlSpecifierSyntax::openBracket)
        .def_readwrite("descriptors", &EdgeControlSpecifierSyntax::descriptors)
        .def_readwrite("closeBracket", &EdgeControlSpecifierSyntax::closeBracket);

    py::class_<TimingCheckEventConditionSyntax, SyntaxNode>(m, "TimingCheckEventConditionSyntax")
        .def_readwrite("tripleAnd", &TimingCheckEventConditionSyntax::tripleAnd)
        .def_readwrite("expr", &TimingCheckEventConditionSyntax::expr);

    py::class_<TimingCheckEventArgSyntax, TimingCheckArgSyntax>(m, "TimingCheckEventArgSyntax")
        .def_readwrite("edge", &TimingCheckEventArgSyntax::edge)
        .def_readwrite("controlSpecifier", &TimingCheckEventArgSyntax::controlSpecifier)
        .def_readwrite("terminal", &TimingCheckEventArgSyntax::terminal)
        .def_readwrite("condition", &TimingCheckEventArgSyntax::condition);

    py::class_<ExpressionTimingCheckArgSyntax, TimingCheckArgSyntax>(m, "ExpressionTimingCheckArgSyntax")
        .def_readwrite("expr", &ExpressionTimingCheckArgSyntax::expr);

    py::class_<SystemTimingCheckSyntax, MemberSyntax>(m, "SystemTimingCheckSyntax")
        .def_readwrite("name", &SystemTimingCheckSyntax::name)
        .def_readwrite("openParen", &SystemTimingCheckSyntax::openParen)
        .def_readwrite("args", &SystemTimingCheckSyntax::args)
        .def_readwrite("closeParen", &SystemTimingCheckSyntax::closeParen)
        .def_readwrite("semi", &SystemTimingCheckSyntax::semi);

    py::class_<SpecifyBlockSyntax, MemberSyntax>(m, "SpecifyBlockSyntax")
        .def_readwrite("specify", &SpecifyBlockSyntax::specify)
        .def_readwrite("items", &SpecifyBlockSyntax::items)
        .def_readwrite("endspecify", &SpecifyBlockSyntax::endspecify);

    py::class_<NetAliasSyntax, MemberSyntax>(m, "NetAliasSyntax")
        .def_readwrite("keyword", &NetAliasSyntax::keyword)
        .def_readwrite("nets", &NetAliasSyntax::nets)
        .def_readwrite("semi", &NetAliasSyntax::semi);

    py::class_<ExternModuleDeclSyntax, MemberSyntax>(m, "ExternModuleDeclSyntax")
        .def_readwrite("externKeyword", &ExternModuleDeclSyntax::externKeyword)
        .def_readwrite("actualAttributes", &ExternModuleDeclSyntax::actualAttributes)
        .def_readwrite("header", &ExternModuleDeclSyntax::header);

    py::class_<ExternUdpDeclSyntax, MemberSyntax>(m, "ExternUdpDeclSyntax")
        .def_readwrite("externKeyword", &ExternUdpDeclSyntax::externKeyword)
        .def_readwrite("actualAttributes", &ExternUdpDeclSyntax::actualAttributes)
        .def_readwrite("primitive", &ExternUdpDeclSyntax::primitive)
        .def_readwrite("name", &ExternUdpDeclSyntax::name)
        .def_readwrite("portList", &ExternUdpDeclSyntax::portList);

    py::class_<ExternInterfaceMethodSyntax, MemberSyntax>(m, "ExternInterfaceMethodSyntax")
        .def_readwrite("externKeyword", &ExternInterfaceMethodSyntax::externKeyword)
        .def_readwrite("forkJoin", &ExternInterfaceMethodSyntax::forkJoin)
        .def_readwrite("prototype", &ExternInterfaceMethodSyntax::prototype)
        .def_readwrite("semi", &ExternInterfaceMethodSyntax::semi);

    py::class_<ConstraintItemSyntax, SyntaxNode>(m, "ConstraintItemSyntax");

    py::class_<DistWeightSyntax, SyntaxNode>(m, "DistWeightSyntax")
        .def_readwrite("op", &DistWeightSyntax::op)
        .def_readwrite("extraOp", &DistWeightSyntax::extraOp)
        .def_readwrite("expr", &DistWeightSyntax::expr);

    py::class_<DistItemSyntax, SyntaxNode>(m, "DistItemSyntax")
        .def_readwrite("range", &DistItemSyntax::range)
        .def_readwrite("weight", &DistItemSyntax::weight);

    py::class_<DistConstraintListSyntax, SyntaxNode>(m, "DistConstraintListSyntax")
        .def_readwrite("dist", &DistConstraintListSyntax::dist)
        .def_readwrite("openBrace", &DistConstraintListSyntax::openBrace)
        .def_readwrite("items", &DistConstraintListSyntax::items)
        .def_readwrite("closeBrace", &DistConstraintListSyntax::closeBrace);

    py::class_<ExpressionOrDistSyntax, ExpressionSyntax>(m, "ExpressionOrDistSyntax")
        .def_readwrite("expr", &ExpressionOrDistSyntax::expr)
        .def_readwrite("distribution", &ExpressionOrDistSyntax::distribution);

    py::class_<ExpressionConstraintSyntax, ConstraintItemSyntax>(m, "ExpressionConstraintSyntax")
        .def_readwrite("soft", &ExpressionConstraintSyntax::soft)
        .def_readwrite("expr", &ExpressionConstraintSyntax::expr)
        .def_readwrite("semi", &ExpressionConstraintSyntax::semi);

    py::class_<UniquenessConstraintSyntax, ConstraintItemSyntax>(m, "UniquenessConstraintSyntax")
        .def_readwrite("unique", &UniquenessConstraintSyntax::unique)
        .def_readwrite("ranges", &UniquenessConstraintSyntax::ranges)
        .def_readwrite("semi", &UniquenessConstraintSyntax::semi);

    py::class_<ImplicationConstraintSyntax, ConstraintItemSyntax>(m, "ImplicationConstraintSyntax")
        .def_readwrite("left", &ImplicationConstraintSyntax::left)
        .def_readwrite("arrow", &ImplicationConstraintSyntax::arrow)
        .def_readwrite("constraints", &ImplicationConstraintSyntax::constraints);

    py::class_<ElseConstraintClauseSyntax, SyntaxNode>(m, "ElseConstraintClauseSyntax")
        .def_readwrite("elseKeyword", &ElseConstraintClauseSyntax::elseKeyword)
        .def_readwrite("constraints", &ElseConstraintClauseSyntax::constraints);

    py::class_<ConditionalConstraintSyntax, ConstraintItemSyntax>(m, "ConditionalConstraintSyntax")
        .def_readwrite("ifKeyword", &ConditionalConstraintSyntax::ifKeyword)
        .def_readwrite("openParen", &ConditionalConstraintSyntax::openParen)
        .def_readwrite("condition", &ConditionalConstraintSyntax::condition)
        .def_readwrite("closeParen", &ConditionalConstraintSyntax::closeParen)
        .def_readwrite("constraints", &ConditionalConstraintSyntax::constraints)
        .def_readwrite("elseClause", &ConditionalConstraintSyntax::elseClause);

    py::class_<LoopConstraintSyntax, ConstraintItemSyntax>(m, "LoopConstraintSyntax")
        .def_readwrite("foreachKeyword", &LoopConstraintSyntax::foreachKeyword)
        .def_readwrite("loopList", &LoopConstraintSyntax::loopList)
        .def_readwrite("constraints", &LoopConstraintSyntax::constraints);

    py::class_<DisableConstraintSyntax, ConstraintItemSyntax>(m, "DisableConstraintSyntax")
        .def_readwrite("disable", &DisableConstraintSyntax::disable)
        .def_readwrite("soft", &DisableConstraintSyntax::soft)
        .def_readwrite("name", &DisableConstraintSyntax::name)
        .def_readwrite("semi", &DisableConstraintSyntax::semi);

    py::class_<SolveBeforeConstraintSyntax, ConstraintItemSyntax>(m, "SolveBeforeConstraintSyntax")
        .def_readwrite("solve", &SolveBeforeConstraintSyntax::solve)
        .def_readwrite("beforeExpr", &SolveBeforeConstraintSyntax::beforeExpr)
        .def_readwrite("before", &SolveBeforeConstraintSyntax::before)
        .def_readwrite("afterExpr", &SolveBeforeConstraintSyntax::afterExpr)
        .def_readwrite("semi", &SolveBeforeConstraintSyntax::semi);

    py::class_<ConstraintBlockSyntax, ConstraintItemSyntax>(m, "ConstraintBlockSyntax")
        .def_readwrite("openBrace", &ConstraintBlockSyntax::openBrace)
        .def_readwrite("items", &ConstraintBlockSyntax::items)
        .def_readwrite("closeBrace", &ConstraintBlockSyntax::closeBrace);

    py::class_<ConstraintPrototypeSyntax, MemberSyntax>(m, "ConstraintPrototypeSyntax")
        .def_readwrite("qualifiers", &ConstraintPrototypeSyntax::qualifiers)
        .def_readwrite("keyword", &ConstraintPrototypeSyntax::keyword)
        .def_readwrite("name", &ConstraintPrototypeSyntax::name)
        .def_readwrite("semi", &ConstraintPrototypeSyntax::semi);

    py::class_<ConstraintDeclarationSyntax, MemberSyntax>(m, "ConstraintDeclarationSyntax")
        .def_readwrite("qualifiers", &ConstraintDeclarationSyntax::qualifiers)
        .def_readwrite("keyword", &ConstraintDeclarationSyntax::keyword)
        .def_readwrite("name", &ConstraintDeclarationSyntax::name)
        .def_readwrite("block", &ConstraintDeclarationSyntax::block);

    py::class_<ParenExpressionListSyntax, SyntaxNode>(m, "ParenExpressionListSyntax")
        .def_readwrite("openParen", &ParenExpressionListSyntax::openParen)
        .def_readwrite("expressions", &ParenExpressionListSyntax::expressions)
        .def_readwrite("closeParen", &ParenExpressionListSyntax::closeParen);

    py::class_<ArrayOrRandomizeMethodExpressionSyntax, ExpressionSyntax>(m, "ArrayOrRandomizeMethodExpressionSyntax")
        .def_readwrite("method", &ArrayOrRandomizeMethodExpressionSyntax::method)
        .def_readwrite("with", &ArrayOrRandomizeMethodExpressionSyntax::with)
        .def_readwrite("args", &ArrayOrRandomizeMethodExpressionSyntax::args)
        .def_readwrite("constraints", &ArrayOrRandomizeMethodExpressionSyntax::constraints);

    py::class_<WithFunctionSampleSyntax, SyntaxNode>(m, "WithFunctionSampleSyntax")
        .def_readwrite("with", &WithFunctionSampleSyntax::with)
        .def_readwrite("function", &WithFunctionSampleSyntax::function)
        .def_readwrite("sample", &WithFunctionSampleSyntax::sample)
        .def_readwrite("portList", &WithFunctionSampleSyntax::portList);

    py::class_<BlockEventExpressionSyntax, SyntaxNode>(m, "BlockEventExpressionSyntax");

    py::class_<BinaryBlockEventExpressionSyntax, BlockEventExpressionSyntax>(m, "BinaryBlockEventExpressionSyntax")
        .def_readwrite("left", &BinaryBlockEventExpressionSyntax::left)
        .def_readwrite("orKeyword", &BinaryBlockEventExpressionSyntax::orKeyword)
        .def_readwrite("right", &BinaryBlockEventExpressionSyntax::right);

    py::class_<PrimaryBlockEventExpressionSyntax, BlockEventExpressionSyntax>(m, "PrimaryBlockEventExpressionSyntax")
        .def_readwrite("keyword", &PrimaryBlockEventExpressionSyntax::keyword)
        .def_readwrite("name", &PrimaryBlockEventExpressionSyntax::name);

    py::class_<BlockCoverageEventSyntax, SyntaxNode>(m, "BlockCoverageEventSyntax")
        .def_readwrite("atat", &BlockCoverageEventSyntax::atat)
        .def_readwrite("openParen", &BlockCoverageEventSyntax::openParen)
        .def_readwrite("expr", &BlockCoverageEventSyntax::expr)
        .def_readwrite("closeParen", &BlockCoverageEventSyntax::closeParen);

    py::class_<CovergroupDeclarationSyntax, MemberSyntax>(m, "CovergroupDeclarationSyntax")
        .def_readwrite("covergroup", &CovergroupDeclarationSyntax::covergroup)
        .def_readwrite("name", &CovergroupDeclarationSyntax::name)
        .def_readwrite("portList", &CovergroupDeclarationSyntax::portList)
        .def_readwrite("event", &CovergroupDeclarationSyntax::event)
        .def_readwrite("semi", &CovergroupDeclarationSyntax::semi)
        .def_readwrite("members", &CovergroupDeclarationSyntax::members)
        .def_readwrite("endgroup", &CovergroupDeclarationSyntax::endgroup)
        .def_readwrite("endBlockName", &CovergroupDeclarationSyntax::endBlockName);

    py::class_<CoverageOptionSyntax, MemberSyntax>(m, "CoverageOptionSyntax")
        .def_readwrite("expr", &CoverageOptionSyntax::expr)
        .def_readwrite("semi", &CoverageOptionSyntax::semi);

    py::class_<CoverageIffClauseSyntax, SyntaxNode>(m, "CoverageIffClauseSyntax")
        .def_readwrite("iff", &CoverageIffClauseSyntax::iff)
        .def_readwrite("openParen", &CoverageIffClauseSyntax::openParen)
        .def_readwrite("expr", &CoverageIffClauseSyntax::expr)
        .def_readwrite("closeParen", &CoverageIffClauseSyntax::closeParen);

    py::class_<CoverpointSyntax, MemberSyntax>(m, "CoverpointSyntax")
        .def_readwrite("type", &CoverpointSyntax::type)
        .def_readwrite("label", &CoverpointSyntax::label)
        .def_readwrite("coverpoint", &CoverpointSyntax::coverpoint)
        .def_readwrite("expr", &CoverpointSyntax::expr)
        .def_readwrite("iff", &CoverpointSyntax::iff)
        .def_readwrite("openBrace", &CoverpointSyntax::openBrace)
        .def_readwrite("members", &CoverpointSyntax::members)
        .def_readwrite("closeBrace", &CoverpointSyntax::closeBrace)
        .def_readwrite("emptySemi", &CoverpointSyntax::emptySemi);

    py::class_<CoverageBinInitializerSyntax, SyntaxNode>(m, "CoverageBinInitializerSyntax");

    py::class_<DefaultCoverageBinInitializerSyntax, CoverageBinInitializerSyntax>(m, "DefaultCoverageBinInitializerSyntax")
        .def_readwrite("defaultKeyword", &DefaultCoverageBinInitializerSyntax::defaultKeyword)
        .def_readwrite("sequenceKeyword", &DefaultCoverageBinInitializerSyntax::sequenceKeyword);

    py::class_<WithClauseSyntax, SyntaxNode>(m, "WithClauseSyntax")
        .def_readwrite("with", &WithClauseSyntax::with)
        .def_readwrite("openParen", &WithClauseSyntax::openParen)
        .def_readwrite("expr", &WithClauseSyntax::expr)
        .def_readwrite("closeParen", &WithClauseSyntax::closeParen);

    py::class_<ExpressionCoverageBinInitializerSyntax, CoverageBinInitializerSyntax>(m, "ExpressionCoverageBinInitializerSyntax")
        .def_readwrite("expr", &ExpressionCoverageBinInitializerSyntax::expr);

    py::class_<RangeCoverageBinInitializerSyntax, CoverageBinInitializerSyntax>(m, "RangeCoverageBinInitializerSyntax")
        .def_readwrite("ranges", &RangeCoverageBinInitializerSyntax::ranges)
        .def_readwrite("withClause", &RangeCoverageBinInitializerSyntax::withClause);

    py::class_<IdWithExprCoverageBinInitializerSyntax, CoverageBinInitializerSyntax>(m, "IdWithExprCoverageBinInitializerSyntax")
        .def_readwrite("id", &IdWithExprCoverageBinInitializerSyntax::id)
        .def_readwrite("withClause", &IdWithExprCoverageBinInitializerSyntax::withClause);

    py::class_<TransRepeatRangeSyntax, SyntaxNode>(m, "TransRepeatRangeSyntax")
        .def_readwrite("openBracket", &TransRepeatRangeSyntax::openBracket)
        .def_readwrite("specifier", &TransRepeatRangeSyntax::specifier)
        .def_readwrite("selector", &TransRepeatRangeSyntax::selector)
        .def_readwrite("closeBracket", &TransRepeatRangeSyntax::closeBracket);

    py::class_<TransRangeSyntax, SyntaxNode>(m, "TransRangeSyntax")
        .def_readwrite("items", &TransRangeSyntax::items)
        .def_readwrite("repeat", &TransRangeSyntax::repeat);

    py::class_<TransSetSyntax, SyntaxNode>(m, "TransSetSyntax")
        .def_readwrite("openParen", &TransSetSyntax::openParen)
        .def_readwrite("ranges", &TransSetSyntax::ranges)
        .def_readwrite("closeParen", &TransSetSyntax::closeParen);

    py::class_<TransListCoverageBinInitializerSyntax, CoverageBinInitializerSyntax>(m, "TransListCoverageBinInitializerSyntax")
        .def_readwrite("sets", &TransListCoverageBinInitializerSyntax::sets);

    py::class_<CoverageBinsArraySizeSyntax, SyntaxNode>(m, "CoverageBinsArraySizeSyntax")
        .def_readwrite("openBracket", &CoverageBinsArraySizeSyntax::openBracket)
        .def_readwrite("expr", &CoverageBinsArraySizeSyntax::expr)
        .def_readwrite("closeBracket", &CoverageBinsArraySizeSyntax::closeBracket);

    py::class_<CoverageBinsSyntax, MemberSyntax>(m, "CoverageBinsSyntax")
        .def_readwrite("wildcard", &CoverageBinsSyntax::wildcard)
        .def_readwrite("keyword", &CoverageBinsSyntax::keyword)
        .def_readwrite("name", &CoverageBinsSyntax::name)
        .def_readwrite("size", &CoverageBinsSyntax::size)
        .def_readwrite("equals", &CoverageBinsSyntax::equals)
        .def_readwrite("initializer", &CoverageBinsSyntax::initializer)
        .def_readwrite("iff", &CoverageBinsSyntax::iff)
        .def_readwrite("semi", &CoverageBinsSyntax::semi);

    py::class_<CoverCrossSyntax, MemberSyntax>(m, "CoverCrossSyntax")
        .def_readwrite("label", &CoverCrossSyntax::label)
        .def_readwrite("cross", &CoverCrossSyntax::cross)
        .def_readwrite("items", &CoverCrossSyntax::items)
        .def_readwrite("iff", &CoverCrossSyntax::iff)
        .def_readwrite("openBrace", &CoverCrossSyntax::openBrace)
        .def_readwrite("members", &CoverCrossSyntax::members)
        .def_readwrite("closeBrace", &CoverCrossSyntax::closeBrace)
        .def_readwrite("emptySemi", &CoverCrossSyntax::emptySemi);

    py::class_<BinsSelectExpressionSyntax, SyntaxNode>(m, "BinsSelectExpressionSyntax");

    py::class_<IntersectClauseSyntax, SyntaxNode>(m, "IntersectClauseSyntax")
        .def_readwrite("intersect", &IntersectClauseSyntax::intersect)
        .def_readwrite("ranges", &IntersectClauseSyntax::ranges);

    py::class_<BinsSelectConditionExprSyntax, BinsSelectExpressionSyntax>(m, "BinsSelectConditionExprSyntax")
        .def_readwrite("binsof", &BinsSelectConditionExprSyntax::binsof)
        .def_readwrite("openParen", &BinsSelectConditionExprSyntax::openParen)
        .def_readwrite("name", &BinsSelectConditionExprSyntax::name)
        .def_readwrite("closeParen", &BinsSelectConditionExprSyntax::closeParen)
        .def_readwrite("intersects", &BinsSelectConditionExprSyntax::intersects);

    py::class_<UnaryBinsSelectExprSyntax, BinsSelectExpressionSyntax>(m, "UnaryBinsSelectExprSyntax")
        .def_readwrite("op", &UnaryBinsSelectExprSyntax::op)
        .def_readwrite("expr", &UnaryBinsSelectExprSyntax::expr);

    py::class_<BinaryBinsSelectExprSyntax, BinsSelectExpressionSyntax>(m, "BinaryBinsSelectExprSyntax")
        .def_readwrite("left", &BinaryBinsSelectExprSyntax::left)
        .def_readwrite("op", &BinaryBinsSelectExprSyntax::op)
        .def_readwrite("right", &BinaryBinsSelectExprSyntax::right);

    py::class_<ParenthesizedBinsSelectExprSyntax, BinsSelectExpressionSyntax>(m, "ParenthesizedBinsSelectExprSyntax")
        .def_readwrite("openParen", &ParenthesizedBinsSelectExprSyntax::openParen)
        .def_readwrite("expr", &ParenthesizedBinsSelectExprSyntax::expr)
        .def_readwrite("closeParen", &ParenthesizedBinsSelectExprSyntax::closeParen);

    py::class_<SimpleBinsSelectExprSyntax, BinsSelectExpressionSyntax>(m, "SimpleBinsSelectExprSyntax")
        .def_readwrite("expr", &SimpleBinsSelectExprSyntax::expr)
        .def_readwrite("matchesClause", &SimpleBinsSelectExprSyntax::matchesClause);

    py::class_<BinSelectWithFilterExprSyntax, BinsSelectExpressionSyntax>(m, "BinSelectWithFilterExprSyntax")
        .def_readwrite("expr", &BinSelectWithFilterExprSyntax::expr)
        .def_readwrite("with", &BinSelectWithFilterExprSyntax::with)
        .def_readwrite("openParen", &BinSelectWithFilterExprSyntax::openParen)
        .def_readwrite("filter", &BinSelectWithFilterExprSyntax::filter)
        .def_readwrite("closeParen", &BinSelectWithFilterExprSyntax::closeParen)
        .def_readwrite("matchesClause", &BinSelectWithFilterExprSyntax::matchesClause);

    py::class_<BinsSelectionSyntax, MemberSyntax>(m, "BinsSelectionSyntax")
        .def_readwrite("keyword", &BinsSelectionSyntax::keyword)
        .def_readwrite("name", &BinsSelectionSyntax::name)
        .def_readwrite("equals", &BinsSelectionSyntax::equals)
        .def_readwrite("expr", &BinsSelectionSyntax::expr)
        .def_readwrite("iff", &BinsSelectionSyntax::iff)
        .def_readwrite("semi", &BinsSelectionSyntax::semi);

    py::class_<SequenceRepetitionSyntax, SyntaxNode>(m, "SequenceRepetitionSyntax")
        .def_readwrite("openBracket", &SequenceRepetitionSyntax::openBracket)
        .def_readwrite("op", &SequenceRepetitionSyntax::op)
        .def_readwrite("selector", &SequenceRepetitionSyntax::selector)
        .def_readwrite("closeBracket", &SequenceRepetitionSyntax::closeBracket);

    py::class_<SimpleSequenceExprSyntax, SequenceExprSyntax>(m, "SimpleSequenceExprSyntax")
        .def_readwrite("expr", &SimpleSequenceExprSyntax::expr)
        .def_readwrite("repetition", &SimpleSequenceExprSyntax::repetition);

    py::class_<SequenceMatchListSyntax, SyntaxNode>(m, "SequenceMatchListSyntax")
        .def_readwrite("comma", &SequenceMatchListSyntax::comma)
        .def_readwrite("items", &SequenceMatchListSyntax::items);

    py::class_<ParenthesizedSequenceExprSyntax, SequenceExprSyntax>(m, "ParenthesizedSequenceExprSyntax")
        .def_readwrite("openParen", &ParenthesizedSequenceExprSyntax::openParen)
        .def_readwrite("expr", &ParenthesizedSequenceExprSyntax::expr)
        .def_readwrite("matchList", &ParenthesizedSequenceExprSyntax::matchList)
        .def_readwrite("closeParen", &ParenthesizedSequenceExprSyntax::closeParen)
        .def_readwrite("repetition", &ParenthesizedSequenceExprSyntax::repetition);

    py::class_<BinarySequenceExprSyntax, SequenceExprSyntax>(m, "BinarySequenceExprSyntax")
        .def_readwrite("left", &BinarySequenceExprSyntax::left)
        .def_readwrite("op", &BinarySequenceExprSyntax::op)
        .def_readwrite("right", &BinarySequenceExprSyntax::right);

    py::class_<FirstMatchSequenceExprSyntax, SequenceExprSyntax>(m, "FirstMatchSequenceExprSyntax")
        .def_readwrite("first_match", &FirstMatchSequenceExprSyntax::first_match)
        .def_readwrite("openParen", &FirstMatchSequenceExprSyntax::openParen)
        .def_readwrite("expr", &FirstMatchSequenceExprSyntax::expr)
        .def_readwrite("matchList", &FirstMatchSequenceExprSyntax::matchList)
        .def_readwrite("closeParen", &FirstMatchSequenceExprSyntax::closeParen);

    py::class_<ClockingSequenceExprSyntax, SequenceExprSyntax>(m, "ClockingSequenceExprSyntax")
        .def_readwrite("event", &ClockingSequenceExprSyntax::event)
        .def_readwrite("expr", &ClockingSequenceExprSyntax::expr);

    py::class_<DelayedSequenceElementSyntax, SyntaxNode>(m, "DelayedSequenceElementSyntax")
        .def_readwrite("doubleHash", &DelayedSequenceElementSyntax::doubleHash)
        .def_readwrite("delayVal", &DelayedSequenceElementSyntax::delayVal)
        .def_readwrite("openBracket", &DelayedSequenceElementSyntax::openBracket)
        .def_readwrite("op", &DelayedSequenceElementSyntax::op)
        .def_readwrite("range", &DelayedSequenceElementSyntax::range)
        .def_readwrite("closeBracket", &DelayedSequenceElementSyntax::closeBracket)
        .def_readwrite("expr", &DelayedSequenceElementSyntax::expr);

    py::class_<DelayedSequenceExprSyntax, SequenceExprSyntax>(m, "DelayedSequenceExprSyntax")
        .def_readwrite("first", &DelayedSequenceExprSyntax::first)
        .def_readwrite("elements", &DelayedSequenceExprSyntax::elements);

    py::class_<SimplePropertyExprSyntax, PropertyExprSyntax>(m, "SimplePropertyExprSyntax")
        .def_readwrite("expr", &SimplePropertyExprSyntax::expr);

    py::class_<ParenthesizedPropertyExprSyntax, PropertyExprSyntax>(m, "ParenthesizedPropertyExprSyntax")
        .def_readwrite("openParen", &ParenthesizedPropertyExprSyntax::openParen)
        .def_readwrite("expr", &ParenthesizedPropertyExprSyntax::expr)
        .def_readwrite("matchList", &ParenthesizedPropertyExprSyntax::matchList)
        .def_readwrite("closeParen", &ParenthesizedPropertyExprSyntax::closeParen);

    py::class_<StrongWeakPropertyExprSyntax, PropertyExprSyntax>(m, "StrongWeakPropertyExprSyntax")
        .def_readwrite("keyword", &StrongWeakPropertyExprSyntax::keyword)
        .def_readwrite("openParen", &StrongWeakPropertyExprSyntax::openParen)
        .def_readwrite("expr", &StrongWeakPropertyExprSyntax::expr)
        .def_readwrite("closeParen", &StrongWeakPropertyExprSyntax::closeParen);

    py::class_<UnaryPropertyExprSyntax, PropertyExprSyntax>(m, "UnaryPropertyExprSyntax")
        .def_readwrite("op", &UnaryPropertyExprSyntax::op)
        .def_readwrite("expr", &UnaryPropertyExprSyntax::expr);

    py::class_<UnarySelectPropertyExprSyntax, PropertyExprSyntax>(m, "UnarySelectPropertyExprSyntax")
        .def_readwrite("op", &UnarySelectPropertyExprSyntax::op)
        .def_readwrite("openBracket", &UnarySelectPropertyExprSyntax::openBracket)
        .def_readwrite("selector", &UnarySelectPropertyExprSyntax::selector)
        .def_readwrite("closeBracket", &UnarySelectPropertyExprSyntax::closeBracket)
        .def_readwrite("expr", &UnarySelectPropertyExprSyntax::expr);

    py::class_<BinaryPropertyExprSyntax, PropertyExprSyntax>(m, "BinaryPropertyExprSyntax")
        .def_readwrite("left", &BinaryPropertyExprSyntax::left)
        .def_readwrite("op", &BinaryPropertyExprSyntax::op)
        .def_readwrite("right", &BinaryPropertyExprSyntax::right);

    py::class_<ClockingPropertyExprSyntax, PropertyExprSyntax>(m, "ClockingPropertyExprSyntax")
        .def_readwrite("event", &ClockingPropertyExprSyntax::event)
        .def_readwrite("expr", &ClockingPropertyExprSyntax::expr);

    py::class_<AcceptOnPropertyExprSyntax, PropertyExprSyntax>(m, "AcceptOnPropertyExprSyntax")
        .def_readwrite("keyword", &AcceptOnPropertyExprSyntax::keyword)
        .def_readwrite("openParen", &AcceptOnPropertyExprSyntax::openParen)
        .def_readwrite("condition", &AcceptOnPropertyExprSyntax::condition)
        .def_readwrite("closeParen", &AcceptOnPropertyExprSyntax::closeParen)
        .def_readwrite("expr", &AcceptOnPropertyExprSyntax::expr);

    py::class_<ElsePropertyClauseSyntax, SyntaxNode>(m, "ElsePropertyClauseSyntax")
        .def_readwrite("elseKeyword", &ElsePropertyClauseSyntax::elseKeyword)
        .def_readwrite("expr", &ElsePropertyClauseSyntax::expr);

    py::class_<ConditionalPropertyExprSyntax, PropertyExprSyntax>(m, "ConditionalPropertyExprSyntax")
        .def_readwrite("ifKeyword", &ConditionalPropertyExprSyntax::ifKeyword)
        .def_readwrite("openParen", &ConditionalPropertyExprSyntax::openParen)
        .def_readwrite("condition", &ConditionalPropertyExprSyntax::condition)
        .def_readwrite("closeParen", &ConditionalPropertyExprSyntax::closeParen)
        .def_readwrite("expr", &ConditionalPropertyExprSyntax::expr)
        .def_readwrite("elseClause", &ConditionalPropertyExprSyntax::elseClause);

    py::class_<PropertyCaseItemSyntax, SyntaxNode>(m, "PropertyCaseItemSyntax");

    py::class_<DefaultPropertyCaseItemSyntax, PropertyCaseItemSyntax>(m, "DefaultPropertyCaseItemSyntax")
        .def_readwrite("defaultKeyword", &DefaultPropertyCaseItemSyntax::defaultKeyword)
        .def_readwrite("colon", &DefaultPropertyCaseItemSyntax::colon)
        .def_readwrite("expr", &DefaultPropertyCaseItemSyntax::expr)
        .def_readwrite("semi", &DefaultPropertyCaseItemSyntax::semi);

    py::class_<StandardPropertyCaseItemSyntax, PropertyCaseItemSyntax>(m, "StandardPropertyCaseItemSyntax")
        .def_readwrite("expressions", &StandardPropertyCaseItemSyntax::expressions)
        .def_readwrite("colon", &StandardPropertyCaseItemSyntax::colon)
        .def_readwrite("expr", &StandardPropertyCaseItemSyntax::expr)
        .def_readwrite("semi", &StandardPropertyCaseItemSyntax::semi);

    py::class_<CasePropertyExprSyntax, PropertyExprSyntax>(m, "CasePropertyExprSyntax")
        .def_readwrite("caseKeyword", &CasePropertyExprSyntax::caseKeyword)
        .def_readwrite("openParen", &CasePropertyExprSyntax::openParen)
        .def_readwrite("expr", &CasePropertyExprSyntax::expr)
        .def_readwrite("closeParen", &CasePropertyExprSyntax::closeParen)
        .def_readwrite("items", &CasePropertyExprSyntax::items)
        .def_readwrite("endcase", &CasePropertyExprSyntax::endcase);

    py::class_<LocalVariableDeclarationSyntax, MemberSyntax>(m, "LocalVariableDeclarationSyntax")
        .def_readwrite("var", &LocalVariableDeclarationSyntax::var)
        .def_readwrite("type", &LocalVariableDeclarationSyntax::type)
        .def_readwrite("declarators", &LocalVariableDeclarationSyntax::declarators)
        .def_readwrite("semi", &LocalVariableDeclarationSyntax::semi);

    py::class_<PropertyDeclarationSyntax, MemberSyntax>(m, "PropertyDeclarationSyntax")
        .def_readwrite("keyword", &PropertyDeclarationSyntax::keyword)
        .def_readwrite("name", &PropertyDeclarationSyntax::name)
        .def_readwrite("portList", &PropertyDeclarationSyntax::portList)
        .def_readwrite("semi", &PropertyDeclarationSyntax::semi)
        .def_readwrite("variables", &PropertyDeclarationSyntax::variables)
        .def_readwrite("propertySpec", &PropertyDeclarationSyntax::propertySpec)
        .def_readwrite("optionalSemi", &PropertyDeclarationSyntax::optionalSemi)
        .def_readwrite("end", &PropertyDeclarationSyntax::end)
        .def_readwrite("endBlockName", &PropertyDeclarationSyntax::endBlockName);

    py::class_<SequenceDeclarationSyntax, MemberSyntax>(m, "SequenceDeclarationSyntax")
        .def_readwrite("keyword", &SequenceDeclarationSyntax::keyword)
        .def_readwrite("name", &SequenceDeclarationSyntax::name)
        .def_readwrite("portList", &SequenceDeclarationSyntax::portList)
        .def_readwrite("semi", &SequenceDeclarationSyntax::semi)
        .def_readwrite("variables", &SequenceDeclarationSyntax::variables)
        .def_readwrite("seqExpr", &SequenceDeclarationSyntax::seqExpr)
        .def_readwrite("optionalSemi", &SequenceDeclarationSyntax::optionalSemi)
        .def_readwrite("end", &SequenceDeclarationSyntax::end)
        .def_readwrite("endBlockName", &SequenceDeclarationSyntax::endBlockName);

    py::class_<CheckerDeclarationSyntax, MemberSyntax>(m, "CheckerDeclarationSyntax")
        .def_readwrite("keyword", &CheckerDeclarationSyntax::keyword)
        .def_readwrite("name", &CheckerDeclarationSyntax::name)
        .def_readwrite("portList", &CheckerDeclarationSyntax::portList)
        .def_readwrite("semi", &CheckerDeclarationSyntax::semi)
        .def_readwrite("members", &CheckerDeclarationSyntax::members)
        .def_readwrite("end", &CheckerDeclarationSyntax::end)
        .def_readwrite("endBlockName", &CheckerDeclarationSyntax::endBlockName);

    py::class_<CheckerDataDeclarationSyntax, MemberSyntax>(m, "CheckerDataDeclarationSyntax")
        .def_readwrite("rand", &CheckerDataDeclarationSyntax::rand)
        .def_readwrite("data", &CheckerDataDeclarationSyntax::data);

    py::class_<CompilationUnitSyntax, SyntaxNode>(m, "CompilationUnitSyntax")
        .def_readwrite("members", &CompilationUnitSyntax::members)
        .def_readwrite("endOfFile", &CompilationUnitSyntax::endOfFile);

    py::class_<LibraryMapSyntax, SyntaxNode>(m, "LibraryMapSyntax")
        .def_readwrite("members", &LibraryMapSyntax::members)
        .def_readwrite("endOfFile", &LibraryMapSyntax::endOfFile);

    py::class_<DirectiveSyntax, SyntaxNode>(m, "DirectiveSyntax")
        .def_readwrite("directive", &DirectiveSyntax::directive);

    py::class_<SimpleDirectiveSyntax, DirectiveSyntax>(m, "SimpleDirectiveSyntax");

    py::class_<IncludeDirectiveSyntax, DirectiveSyntax>(m, "IncludeDirectiveSyntax")
        .def_readwrite("fileName", &IncludeDirectiveSyntax::fileName);

    py::class_<ConditionalDirectiveExpressionSyntax, SyntaxNode>(m, "ConditionalDirectiveExpressionSyntax");

    py::class_<NamedConditionalDirectiveExpressionSyntax, ConditionalDirectiveExpressionSyntax>(m, "NamedConditionalDirectiveExpressionSyntax")
        .def_readwrite("name", &NamedConditionalDirectiveExpressionSyntax::name);

    py::class_<UnaryConditionalDirectiveExpressionSyntax, ConditionalDirectiveExpressionSyntax>(m, "UnaryConditionalDirectiveExpressionSyntax")
        .def_readwrite("op", &UnaryConditionalDirectiveExpressionSyntax::op)
        .def_readwrite("operand", &UnaryConditionalDirectiveExpressionSyntax::operand);

    py::class_<BinaryConditionalDirectiveExpressionSyntax, ConditionalDirectiveExpressionSyntax>(m, "BinaryConditionalDirectiveExpressionSyntax")
        .def_readwrite("left", &BinaryConditionalDirectiveExpressionSyntax::left)
        .def_readwrite("op", &BinaryConditionalDirectiveExpressionSyntax::op)
        .def_readwrite("right", &BinaryConditionalDirectiveExpressionSyntax::right);

    py::class_<ParenthesizedConditionalDirectiveExpressionSyntax, ConditionalDirectiveExpressionSyntax>(m, "ParenthesizedConditionalDirectiveExpressionSyntax")
        .def_readwrite("openParen", &ParenthesizedConditionalDirectiveExpressionSyntax::openParen)
        .def_readwrite("operand", &ParenthesizedConditionalDirectiveExpressionSyntax::operand)
        .def_readwrite("closeParen", &ParenthesizedConditionalDirectiveExpressionSyntax::closeParen);

    py::class_<ConditionalBranchDirectiveSyntax, DirectiveSyntax>(m, "ConditionalBranchDirectiveSyntax")
        .def_readwrite("expr", &ConditionalBranchDirectiveSyntax::expr)
        .def_readwrite("disabledTokens", &ConditionalBranchDirectiveSyntax::disabledTokens);

    py::class_<UnconditionalBranchDirectiveSyntax, DirectiveSyntax>(m, "UnconditionalBranchDirectiveSyntax")
        .def_readwrite("disabledTokens", &UnconditionalBranchDirectiveSyntax::disabledTokens);

    py::class_<MacroArgumentDefaultSyntax, SyntaxNode>(m, "MacroArgumentDefaultSyntax")
        .def_readwrite("equals", &MacroArgumentDefaultSyntax::equals)
        .def_readwrite("tokens", &MacroArgumentDefaultSyntax::tokens);

    py::class_<MacroFormalArgumentSyntax, SyntaxNode>(m, "MacroFormalArgumentSyntax")
        .def_readwrite("name", &MacroFormalArgumentSyntax::name)
        .def_readwrite("defaultValue", &MacroFormalArgumentSyntax::defaultValue);

    py::class_<MacroFormalArgumentListSyntax, SyntaxNode>(m, "MacroFormalArgumentListSyntax")
        .def_readwrite("openParen", &MacroFormalArgumentListSyntax::openParen)
        .def_readwrite("args", &MacroFormalArgumentListSyntax::args)
        .def_readwrite("closeParen", &MacroFormalArgumentListSyntax::closeParen);

    py::class_<DefineDirectiveSyntax, DirectiveSyntax>(m, "DefineDirectiveSyntax")
        .def_readwrite("name", &DefineDirectiveSyntax::name)
        .def_readwrite("formalArguments", &DefineDirectiveSyntax::formalArguments)
        .def_readwrite("body", &DefineDirectiveSyntax::body);

    py::class_<MacroActualArgumentSyntax, SyntaxNode>(m, "MacroActualArgumentSyntax")
        .def_readwrite("tokens", &MacroActualArgumentSyntax::tokens);

    py::class_<MacroActualArgumentListSyntax, SyntaxNode>(m, "MacroActualArgumentListSyntax")
        .def_readwrite("openParen", &MacroActualArgumentListSyntax::openParen)
        .def_readwrite("args", &MacroActualArgumentListSyntax::args)
        .def_readwrite("closeParen", &MacroActualArgumentListSyntax::closeParen);

    py::class_<MacroUsageSyntax, DirectiveSyntax>(m, "MacroUsageSyntax")
        .def_readwrite("args", &MacroUsageSyntax::args);

    py::class_<TimeScaleDirectiveSyntax, DirectiveSyntax>(m, "TimeScaleDirectiveSyntax")
        .def_readwrite("timeUnit", &TimeScaleDirectiveSyntax::timeUnit)
        .def_readwrite("slash", &TimeScaleDirectiveSyntax::slash)
        .def_readwrite("timePrecision", &TimeScaleDirectiveSyntax::timePrecision);

    py::class_<DefaultNetTypeDirectiveSyntax, DirectiveSyntax>(m, "DefaultNetTypeDirectiveSyntax")
        .def_readwrite("netType", &DefaultNetTypeDirectiveSyntax::netType);

    py::class_<UnconnectedDriveDirectiveSyntax, DirectiveSyntax>(m, "UnconnectedDriveDirectiveSyntax")
        .def_readwrite("strength", &UnconnectedDriveDirectiveSyntax::strength);

    py::class_<LineDirectiveSyntax, DirectiveSyntax>(m, "LineDirectiveSyntax")
        .def_readwrite("lineNumber", &LineDirectiveSyntax::lineNumber)
        .def_readwrite("fileName", &LineDirectiveSyntax::fileName)
        .def_readwrite("level", &LineDirectiveSyntax::level);

    py::class_<UndefDirectiveSyntax, DirectiveSyntax>(m, "UndefDirectiveSyntax")
        .def_readwrite("name", &UndefDirectiveSyntax::name);

    py::class_<BeginKeywordsDirectiveSyntax, DirectiveSyntax>(m, "BeginKeywordsDirectiveSyntax")
        .def_readwrite("versionSpecifier", &BeginKeywordsDirectiveSyntax::versionSpecifier);

    py::class_<PragmaExpressionSyntax, SyntaxNode>(m, "PragmaExpressionSyntax");

    py::class_<SimplePragmaExpressionSyntax, PragmaExpressionSyntax>(m, "SimplePragmaExpressionSyntax")
        .def_readwrite("value", &SimplePragmaExpressionSyntax::value);

    py::class_<NameValuePragmaExpressionSyntax, PragmaExpressionSyntax>(m, "NameValuePragmaExpressionSyntax")
        .def_readwrite("name", &NameValuePragmaExpressionSyntax::name)
        .def_readwrite("equals", &NameValuePragmaExpressionSyntax::equals)
        .def_readwrite("value", &NameValuePragmaExpressionSyntax::value);

    py::class_<NumberPragmaExpressionSyntax, PragmaExpressionSyntax>(m, "NumberPragmaExpressionSyntax")
        .def_readwrite("size", &NumberPragmaExpressionSyntax::size)
        .def_readwrite("base", &NumberPragmaExpressionSyntax::base)
        .def_readwrite("value", &NumberPragmaExpressionSyntax::value);

    py::class_<ParenPragmaExpressionSyntax, PragmaExpressionSyntax>(m, "ParenPragmaExpressionSyntax")
        .def_readwrite("openParen", &ParenPragmaExpressionSyntax::openParen)
        .def_readwrite("values", &ParenPragmaExpressionSyntax::values)
        .def_readwrite("closeParen", &ParenPragmaExpressionSyntax::closeParen);

    py::class_<PragmaDirectiveSyntax, DirectiveSyntax>(m, "PragmaDirectiveSyntax")
        .def_readwrite("name", &PragmaDirectiveSyntax::name)
        .def_readwrite("args", &PragmaDirectiveSyntax::args);

    py::class_<ConfigCellIdentifierSyntax, SyntaxNode>(m, "ConfigCellIdentifierSyntax")
        .def_readwrite("library", &ConfigCellIdentifierSyntax::library)
        .def_readwrite("dot", &ConfigCellIdentifierSyntax::dot)
        .def_readwrite("cell", &ConfigCellIdentifierSyntax::cell);

    py::class_<ConfigRuleClauseSyntax, SyntaxNode>(m, "ConfigRuleClauseSyntax");

    py::class_<ConfigLiblistSyntax, ConfigRuleClauseSyntax>(m, "ConfigLiblistSyntax")
        .def_readwrite("liblist", &ConfigLiblistSyntax::liblist)
        .def_readwrite("libraries", &ConfigLiblistSyntax::libraries);

    py::class_<ConfigUseClauseSyntax, ConfigRuleClauseSyntax>(m, "ConfigUseClauseSyntax")
        .def_readwrite("use", &ConfigUseClauseSyntax::use)
        .def_readwrite("name", &ConfigUseClauseSyntax::name)
        .def_readwrite("paramAssignments", &ConfigUseClauseSyntax::paramAssignments)
        .def_readwrite("colon", &ConfigUseClauseSyntax::colon)
        .def_readwrite("config", &ConfigUseClauseSyntax::config);

    py::class_<ConfigRuleSyntax, SyntaxNode>(m, "ConfigRuleSyntax");

    py::class_<DefaultConfigRuleSyntax, ConfigRuleSyntax>(m, "DefaultConfigRuleSyntax")
        .def_readwrite("defaultKeyword", &DefaultConfigRuleSyntax::defaultKeyword)
        .def_readwrite("liblist", &DefaultConfigRuleSyntax::liblist)
        .def_readwrite("semi", &DefaultConfigRuleSyntax::semi);

    py::class_<ConfigInstanceIdentifierSyntax, SyntaxNode>(m, "ConfigInstanceIdentifierSyntax")
        .def_readwrite("dot", &ConfigInstanceIdentifierSyntax::dot)
        .def_readwrite("name", &ConfigInstanceIdentifierSyntax::name);

    py::class_<InstanceConfigRuleSyntax, ConfigRuleSyntax>(m, "InstanceConfigRuleSyntax")
        .def_readwrite("instance", &InstanceConfigRuleSyntax::instance)
        .def_readwrite("topModule", &InstanceConfigRuleSyntax::topModule)
        .def_readwrite("instanceNames", &InstanceConfigRuleSyntax::instanceNames)
        .def_readwrite("ruleClause", &InstanceConfigRuleSyntax::ruleClause)
        .def_readwrite("semi", &InstanceConfigRuleSyntax::semi);

    py::class_<CellConfigRuleSyntax, ConfigRuleSyntax>(m, "CellConfigRuleSyntax")
        .def_readwrite("cell", &CellConfigRuleSyntax::cell)
        .def_readwrite("name", &CellConfigRuleSyntax::name)
        .def_readwrite("ruleClause", &CellConfigRuleSyntax::ruleClause)
        .def_readwrite("semi", &CellConfigRuleSyntax::semi);

    py::class_<ConfigDeclarationSyntax, MemberSyntax>(m, "ConfigDeclarationSyntax")
        .def_readwrite("config", &ConfigDeclarationSyntax::config)
        .def_readwrite("name", &ConfigDeclarationSyntax::name)
        .def_readwrite("semi1", &ConfigDeclarationSyntax::semi1)
        .def_readwrite("localparams", &ConfigDeclarationSyntax::localparams)
        .def_readwrite("design", &ConfigDeclarationSyntax::design)
        .def_readwrite("topCells", &ConfigDeclarationSyntax::topCells)
        .def_readwrite("semi2", &ConfigDeclarationSyntax::semi2)
        .def_readwrite("rules", &ConfigDeclarationSyntax::rules)
        .def_readwrite("endconfig", &ConfigDeclarationSyntax::endconfig)
        .def_readwrite("blockName", &ConfigDeclarationSyntax::blockName);

    py::class_<FilePathSpecSyntax, SyntaxNode>(m, "FilePathSpecSyntax")
        .def_readwrite("path", &FilePathSpecSyntax::path);

    py::class_<LibraryIncDirClauseSyntax, SyntaxNode>(m, "LibraryIncDirClauseSyntax")
        .def_readwrite("minus", &LibraryIncDirClauseSyntax::minus)
        .def_readwrite("incdir", &LibraryIncDirClauseSyntax::incdir)
        .def_readwrite("filePaths", &LibraryIncDirClauseSyntax::filePaths);

    py::class_<LibraryDeclarationSyntax, MemberSyntax>(m, "LibraryDeclarationSyntax")
        .def_readwrite("library", &LibraryDeclarationSyntax::library)
        .def_readwrite("name", &LibraryDeclarationSyntax::name)
        .def_readwrite("filePaths", &LibraryDeclarationSyntax::filePaths)
        .def_readwrite("incDirClause", &LibraryDeclarationSyntax::incDirClause)
        .def_readwrite("semi", &LibraryDeclarationSyntax::semi);

    py::class_<LibraryIncludeStatementSyntax, MemberSyntax>(m, "LibraryIncludeStatementSyntax")
        .def_readwrite("include", &LibraryIncludeStatementSyntax::include)
        .def_readwrite("filePath", &LibraryIncludeStatementSyntax::filePath)
        .def_readwrite("semi", &LibraryIncludeStatementSyntax::semi);

}
